searchNodes=[{"doc":"Membrane Filter, that can be used to create a child that will be used to debug data flowing thouth pipeline. Any buffers, stream formats and events arriving to Elixir.Membrane.Debug.Filter will be forwarded by it to the opposite side than the one from which they came. Usage example: child ( :source , CustomSource ) |&gt; child ( :filter , % Membrane.Debug.Filter { handle_buffer : &amp; IO . inspect ( &amp;1 , label : &quot;buffer&quot; ) , handle_stream_format : &amp; IO . inspect ( &amp;1 , label : &quot;stream format&quot; ) } ) |&gt; child ( :sink , CustomSink ) Element options Passed via struct Membrane.Debug.Filter.t/0 handle_buffer ( Buffer . t ( ) -&gt; any ( ) ) Default value: &amp;Membrane.Debug.Filter.noop/1 Function with arity 1, that will be called with all buffers handled by this sink. Result of this function is ignored. handle_event ( Event . t ( ) -&gt; any ( ) ) Default value: &amp;Membrane.Debug.Filter.noop/1 Function with arity 1, that will be called with all events handled by this sink. Result of this function is ignored. handle_stream_format ( StreamFormat . t ( ) -&gt; any ( ) ) Default value: &amp;Membrane.Debug.Filter.noop/1 Function with arity 1, that will be called with all stream formats handled by this sink. Result of this function is ignored. Pads :input Accepted formats: _any Direction: :input Availability: :always Flow control: :auto Demand unit: nil :output Accepted formats: _any Direction: :output Availability: :always Flow control: :auto Demand unit: nil","ref":"Membrane.Debug.Filter.html","title":"Membrane.Debug.Filter","type":"module"},{"doc":"","ref":"Membrane.Debug.Filter.html#noop/1","title":"Membrane.Debug.Filter.noop/1","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.Debug.Filter.html#options/0","title":"Membrane.Debug.Filter.options/0","type":"function"},{"doc":"Struct containing options for Membrane.Debug.Filter","ref":"Membrane.Debug.Filter.html#t:t/0","title":"Membrane.Debug.Filter.t/0","type":"type"},{"doc":"Membrane Sink, that can be used to create a child that will be used to debug data flowing thouth pipeline. Usage example: child ( :source , CustomSource ) |&gt; child ( :sink , % Membrane.Debug.Sink { handle_buffer : &amp; IO . inspect ( &amp;1 , label : &quot;buffer&quot; ) , handle_event : &amp; IO . inspect ( &amp;1 , label : &quot;event&quot; ) } ) Element options Passed via struct Membrane.Debug.Sink.t/0 handle_buffer ( Buffer . t ( ) -&gt; any ( ) ) Default value: &amp;Membrane.Debug.Sink.noop/1 Function with arity 1, that will be called with all buffers handled by this sink. Result of this function is ignored. handle_event ( Event . t ( ) -&gt; any ( ) ) Default value: &amp;Membrane.Debug.Sink.noop/1 Function with arity 1, that will be called with all events handled by this sink. Result of this function is ignored. handle_stream_format ( StreamFormat . t ( ) -&gt; any ( ) ) Default value: &amp;Membrane.Debug.Sink.noop/1 Function with arity 1, that will be called with all stream formats handled by this sink. Result of this function is ignored. Pads :input Accepted formats: _any Direction: :input Availability: :always Flow control: :auto Demand unit: nil","ref":"Membrane.Debug.Sink.html","title":"Membrane.Debug.Sink","type":"module"},{"doc":"","ref":"Membrane.Debug.Sink.html#noop/1","title":"Membrane.Debug.Sink.noop/1","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.Debug.Sink.html#options/0","title":"Membrane.Debug.Sink.options/0","type":"function"},{"doc":"Struct containing options for Membrane.Debug.Sink","ref":"Membrane.Debug.Sink.html#t:t/0","title":"Membrane.Debug.Sink.t/0","type":"type"},{"doc":"Module containing functions for constructing and supervising pipelines. Pipelines are units that make it possible to instantiate, link and manage elements and bins in convenient way (actually they should always be used inside a pipeline). Linking pipeline children together enables them to pass data to one another, and process it in different ways. To create a pipeline, use the __using__/1 macro and implement callbacks of Membrane.Pipeline behaviour. For details on instantiating and linking children, see Membrane.ChildrenSpec . Starting and supervision Pipeline can be started with start_link/2 or start/2 functions. They both return {:ok, supervisor_pid, pipeline_pid} in case of success, because the pipeline is always spawned under a dedicated supervisor. The supervisor never restarts the pipeline, but it makes sure that the pipeline and its children terminate properly. If the pipeline needs to be restarted in case of failure, it should be spawned under another supervisor with a proper strategy. Starting under a supervision tree The pipeline can be spawned under a supervision tree like any GenServer . Also, __using__/1 macro injects a child_spec/1 function. A simple scenario can look like: defmodule MyPipeline do use Membrane.Pipeline def start_link ( options ) do Membrane.Pipeline . start_link ( __MODULE__ , options , name : MyPipeline ) end # ... end Supervisor . start_link ( [ { MyPipeline , option : :value } ] , strategy : :one_for_one ) send ( MyPipeline , :message ) Starting outside of a supervision tree When starting a pipeline outside a supervision tree and willing to interact with the pipeline by pid, pipeline_pid returned from start_link can be used, for example { :ok , _supervisor_pid , pipeline_pid } = Membrane.Pipeline . start_link ( MyPipeline , option : :value ) send ( pipeline_pid , :message ) Visualizing pipeline's supervision tree Pipeline's internal supervision tree can be looked up with Applications tab of Erlang's Observer or with Livebook's Kino library. For debugging (and ONLY for debugging) purposes, you may use the following configuration: config :membrane_core , unsafely_name_processes_for_observer : [ :components ] that makes the observer's process tree graph more readable by naming pipeline's descendants, for example: .","ref":"Membrane.Pipeline.html","title":"Membrane.Pipeline","type":"behaviour"},{"doc":"Brings all the stuff necessary to implement a pipeline. Options: :bring_spec? - if true (default) imports and aliases Membrane.ChildrenSpec :bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Pipeline.html#__using__/1","title":"Membrane.Pipeline.__using__/1","type":"macro"},{"doc":"","ref":"Membrane.Pipeline.html#call/3","title":"Membrane.Pipeline.call/3","type":"function"},{"doc":"Callback invoked when pipeline is called using a synchronous call. Context passed to this callback contains additional field :from .","ref":"Membrane.Pipeline.html#c:handle_call/3","title":"Membrane.Pipeline.handle_call/3","type":"callback"},{"doc":"Callback invoked when a notification comes in from an element.","ref":"Membrane.Pipeline.html#c:handle_child_notification/4","title":"Membrane.Pipeline.handle_child_notification/4","type":"callback"},{"doc":"Callback invoked when a child removes its pad. The callback won't be invoked, when you have initiated the pad removal, e.g. when you have returned t:Membrane.Pipeline.Action.remove_link() action which made one of your children's pads be removed.","ref":"Membrane.Pipeline.html#c:handle_child_pad_removed/4","title":"Membrane.Pipeline.handle_child_pad_removed/4","type":"callback"},{"doc":"Callback invoked when crash of the crash group happens. Context passed to this callback contains 2 additional fields: :members and :crash_initiator .","ref":"Membrane.Pipeline.html#c:handle_crash_group_down/3","title":"Membrane.Pipeline.handle_crash_group_down/3","type":"callback"},{"doc":"Callback invoked when a child element finishes processing stream via given pad.","ref":"Membrane.Pipeline.html#c:handle_element_end_of_stream/4","title":"Membrane.Pipeline.handle_element_end_of_stream/4","type":"callback"},{"doc":"Callback invoked when a child element starts processing stream via given pad.","ref":"Membrane.Pipeline.html#c:handle_element_start_of_stream/4","title":"Membrane.Pipeline.handle_element_start_of_stream/4","type":"callback"},{"doc":"Callback invoked when pipeline receives a message that is not recognized as an internal membrane message. Useful for receiving data sent from NIFs or other stuff.","ref":"Membrane.Pipeline.html#c:handle_info/3","title":"Membrane.Pipeline.handle_info/3","type":"callback"},{"doc":"Callback invoked on initialization of pipeline. This callback is synchronous: the process which started the pipeline waits until handle_init finishes. For that reason, it's important to do any long-lasting or complex work in handle_setup/2 , while handle_init should be used for things like parsing options, initializing state or spawning children.","ref":"Membrane.Pipeline.html#c:handle_init/2","title":"Membrane.Pipeline.handle_init/2","type":"callback"},{"doc":"Callback invoked when pipeline switches the playback to :playing .","ref":"Membrane.Pipeline.html#c:handle_playing/2","title":"Membrane.Pipeline.handle_playing/2","type":"callback"},{"doc":"Callback invoked on pipeline startup, right after handle_init/2 . Any long-lasting or complex initialization should happen here.","ref":"Membrane.Pipeline.html#c:handle_setup/2","title":"Membrane.Pipeline.handle_setup/2","type":"callback"},{"doc":"Callback invoked when children of Membrane.ChildrenSpec are started.","ref":"Membrane.Pipeline.html#c:handle_spec_started/3","title":"Membrane.Pipeline.handle_spec_started/3","type":"callback"},{"doc":"Callback invoked when pipeline is requested to terminate with terminate/2 . By default it returns Membrane.Pipeline.Action.terminate/0 with reason :normal .","ref":"Membrane.Pipeline.html#c:handle_terminate_request/2","title":"Membrane.Pipeline.handle_terminate_request/2","type":"callback"},{"doc":"Callback invoked upon each timer tick. A timer can be started with Membrane.Pipeline.Action.start_timer action.","ref":"Membrane.Pipeline.html#c:handle_tick/3","title":"Membrane.Pipeline.handle_tick/3","type":"callback"},{"doc":"Checks whether module is a pipeline.","ref":"Membrane.Pipeline.html#pipeline?/1","title":"Membrane.Pipeline.pipeline?/1","type":"function"},{"doc":"Does the same as start_link/3 but starts process outside of supervision tree.","ref":"Membrane.Pipeline.html#start/3","title":"Membrane.Pipeline.start/3","type":"function"},{"doc":"Starts the Pipeline based on given module and links it to the current process. Pipeline options are passed to module's handle_init/2 callback. Note that this function returns {:ok, supervisor_pid, pipeline_pid} in case of success. Check the 'Starting and supervision' section of the moduledoc for details.","ref":"Membrane.Pipeline.html#start_link/3","title":"Membrane.Pipeline.start_link/3","type":"function"},{"doc":"Terminates the pipeline. Accepts three options: asynchronous? - if set to true , pipline termination won't be blocking and will be executed in the process, which pid is returned as function result. If set to false , pipeline termination will be blocking and will be executed in the process that called this function. Defaults to false . timeout - tells how much time (ms) to wait for pipeline to get gracefully terminated. Defaults to 5000. force? - if set to true and pipeline is still alive after timeout , pipeline will be killed using Process.exit/2 with reason :kill , and function will return {:error, :timeout} . If set to false and pipeline is still alive after timeout , function will raise an error. Defaults to false . Returns: {:ok, pid} - if option asynchronous?: true was passed. :ok - if pipeline was gracefully terminated within timeout . {:error, :timeout} - if pipeline was killed after a timeout .","ref":"Membrane.Pipeline.html#terminate/2","title":"Membrane.Pipeline.terminate/2","type":"function"},{"doc":"Defines return values from Pipeline callback functions. Return values {[action], state} - Return a list of actions that will be performed within the pipeline. This can be used to start new children, or to send messages to specific children, for example. Actions are a tuple of {type, arguments} , so may be written in the form a keyword list. See Membrane.Pipeline.Action for more info.","ref":"Membrane.Pipeline.html#t:callback_return/0","title":"Membrane.Pipeline.callback_return/0","type":"type"},{"doc":"","ref":"Membrane.Pipeline.html#t:config/0","title":"Membrane.Pipeline.config/0","type":"type"},{"doc":"","ref":"Membrane.Pipeline.html#t:config_entry/0","title":"Membrane.Pipeline.config_entry/0","type":"type"},{"doc":"","ref":"Membrane.Pipeline.html#t:name/0","title":"Membrane.Pipeline.name/0","type":"type"},{"doc":"","ref":"Membrane.Pipeline.html#t:on_start/0","title":"Membrane.Pipeline.on_start/0","type":"type"},{"doc":"Defines options that can be passed to start/3 / start_link/3 and received in handle_init/2 callback.","ref":"Membrane.Pipeline.html#t:pipeline_options/0","title":"Membrane.Pipeline.pipeline_options/0","type":"type"},{"doc":"","ref":"Membrane.Pipeline.html#t:state/0","title":"Membrane.Pipeline.state/0","type":"type"},{"doc":"This module contains type specifications of actions that can be returned from pipeline callbacks. Returning actions is a way of pipeline interaction with other components and parts of framework. Each action may be returned by any callback unless explicitly stated otherwise.","ref":"Membrane.Pipeline.Action.html","title":"Membrane.Pipeline.Action","type":"module"},{"doc":"Action that sends a message to a child identified by name.","ref":"Membrane.Pipeline.Action.html#t:notify_child/0","title":"Membrane.Pipeline.Action.notify_child/0","type":"type"},{"doc":"","ref":"Membrane.Pipeline.Action.html#t:playback/0","title":"Membrane.Pipeline.Action.playback/0","type":"type"},{"doc":"","ref":"Membrane.Pipeline.Action.html#t:remove_child/0","title":"Membrane.Pipeline.Action.remove_child/0","type":"type"},{"doc":"Action that stops, unlinks and removes specified child/children from the pipeline. A child name, list of children names, children group id or a list of children group ids can be specified as an argument.","ref":"Membrane.Pipeline.Action.html#t:remove_children/0","title":"Membrane.Pipeline.Action.remove_children/0","type":"type"},{"doc":"Action that removes link, which relates to specified child and pad. Removed link has to have dynamic pads on both ends.","ref":"Membrane.Pipeline.Action.html#t:remove_link/0","title":"Membrane.Pipeline.Action.remove_link/0","type":"type"},{"doc":"Action that replies to a Membrane.Pipeline.call/3 . Can be returned only from the Membrane.Pipeline.handle_call/3 callback, in which context the caller reference is available, under the :from key.","ref":"Membrane.Pipeline.Action.html#t:reply/0","title":"Membrane.Pipeline.Action.reply/0","type":"type"},{"doc":"Action that replies to a Membrane.Pipeline.call/3 . Useful when one does not want to reply in Membrane.Pipeline.handle_call/3 callback. A caller reference is required to be passed, so one needs to save this reference from the Membrane.Pipeline.CallbackContext.Call , where it is available under the :from key.","ref":"Membrane.Pipeline.Action.html#t:reply_to/0","title":"Membrane.Pipeline.Action.reply_to/0","type":"type"},{"doc":"Action that manages the end of the component setup. By default, component setup ends with the end of Membrane.Pipeline.handle_setup/2 callback. If {:setup, :incomplete} is returned there, setup lasts until {:setup, :complete} is returned from antoher callback. Untils the setup lasts, the component won't enter :playing playback.","ref":"Membrane.Pipeline.Action.html#t:setup/0","title":"Membrane.Pipeline.Action.setup/0","type":"type"},{"doc":"Action that instantiates children and links them according to Membrane.ChildrenSpec . Children's playback is changed to the current pipeline state. Membrane.Pipeline.handle_spec_started/3 callback is executed once it happens.","ref":"Membrane.Pipeline.Action.html#t:spec/0","title":"Membrane.Pipeline.Action.spec/0","type":"type"},{"doc":"Starts a timer that will invoke Membrane.Pipeline.handle_tick/3 callback every interval according to the given clock . The timer's id is passed to the Membrane.Pipeline.handle_tick/3 callback and can be used for changing its interval via timer_interval/0 or stopping it via stop_timer/0 . If interval is set to :no_interval , the timer won't issue any ticks until the interval is set with timer_interval/0 action. If no clock is passed, pipeline clock is chosen. Timers use Process.send_after/3 under the hood.","ref":"Membrane.Pipeline.Action.html#t:start_timer/0","title":"Membrane.Pipeline.Action.start_timer/0","type":"type"},{"doc":"Stops a timer started with start_timer/0 action. This action is atomic: stopping timer guarantees that no ticks will arrive from it.","ref":"Membrane.Pipeline.Action.html#t:stop_timer/0","title":"Membrane.Pipeline.Action.stop_timer/0","type":"type"},{"doc":"Type describing actions that can be returned from pipeline callbacks. Returning actions is a way of pipeline interaction with its children and other parts of framework.","ref":"Membrane.Pipeline.Action.html#t:t/0","title":"Membrane.Pipeline.Action.t/0","type":"type"},{"doc":"Terminates the pipeline with given reason. Termination reason follows the OTP semantics: Use :normal for graceful termination. If the pipeline has no children, it terminates immediately. Otherwise, it switches to the zombie mode, requests all the children to terminate, waits for them to terminate and then terminates itself. In the zombie mode, no pipeline callbacks are called and all messages and calls to the pipeline are ignored (apart from Membrane internal messages) If the reason is other than :normal , the pipeline terminates immediately. The pipeline supervisor terminates all the children with the reason :shutdown If the reason is neither :normal , :shutdown nor {:shutdown, term} , an error is logged","ref":"Membrane.Pipeline.Action.html#t:terminate/0","title":"Membrane.Pipeline.Action.terminate/0","type":"type"},{"doc":"Changes interval of a timer started with start_timer/0 . Permitted only from Membrane.Pipeline.handle_tick/3 , unless the interval was previously set to :no_interval . If the interval is :no_interval , the timer won't issue any ticks until another timer_interval/0 action. Otherwise, the timer will issue ticks every new interval . The next tick after interval change is scheduled at new_interval + previous_time , where previous_time is the time of the latest tick or the time of returning start_timer/0 action if no tick has been sent yet. Note that if current_time - previous_time &gt; new_interval , a burst of div(current_time - previous_time, new_interval) ticks is issued immediately.","ref":"Membrane.Pipeline.Action.html#t:timer_interval/0","title":"Membrane.Pipeline.Action.timer_interval/0","type":"type"},{"doc":"Module describing context passed to the Membrane.Pipeline callbacks.","ref":"Membrane.Pipeline.CallbackContext.html","title":"Membrane.Pipeline.CallbackContext","type":"module"},{"doc":"Type describing context passed to the Membrane.Pipeline callbacks. Field :from is present only in Membrane.Pipeline.handle_call/3 . Fields :members and :crash_initiator are present only in Membrane.Pipeline.handle_crash_group_down/3 .","ref":"Membrane.Pipeline.CallbackContext.html#t:t/0","title":"Membrane.Pipeline.CallbackContext.t/0","type":"type"},{"doc":"An abstract module aggregating all the messages that can be sent by the RCPipeline . Check t/0 for available messages.","ref":"Membrane.RCMessage.html","title":"Membrane.RCMessage","type":"module"},{"doc":"The type describing all possible Membrane.RCMessage s.","ref":"Membrane.RCMessage.html#t:t/0","title":"Membrane.RCMessage.t/0","type":"type"},{"doc":"Remote controlled pipeline - a basic Membrane.Pipeline implementation that can be remotely controlled from an external process. The easiest way to start this pipeline is to use start_link!/1 pipeline = Membrane.RCPipeline . start_link! ( ) The controlling process can request the execution of arbitrary valid Membrane.Pipeline.Action : children = ... links = ... actions = [ { :spec , children ++ links } ] Pipeline . exec_actions ( pipeline , actions ) The controlling process can also subscribe to the messages sent by the pipeline and later on synchronously await for these messages: # subscribes to message which is sent when the pipeline enters `playing` Membrane.RCPipeline . subscribe ( pipeline , % Message.Playing { } ) ... # awaits for the message sent when the pipeline enters :playing playback Membrane.RCPipeline . await_playing ( pipeline ) ... Membrane.RCPipeline can be used when there is no need for introducing a custom logic in the Membrane.Pipeline callbacks implementation. An example of usage could be running a pipeline from the elixir script. Membrane.RCPipeline sends the following messages: Membrane.RCMessage.Playing.t/0 sent when pipeline enters playing playback, Membrane.RCMessage.StartOfStream.t/0 sent when one of direct pipeline children informs the pipeline about start of a stream, Membrane.RCMessage.EndOfStream.t/0 sent when one of direct pipeline children informs the pipeline about end of a stream, Membrane.RCMessage.Notification.t/0 sent when pipeline receives notification from one of its children, Membrane.RCMessage.Terminated.t/0 sent when the pipeline gracefully terminates.","ref":"Membrane.RCPipeline.html","title":"Membrane.RCPipeline","type":"module"},{"doc":"Awaits for the first Membrane.RCMessage.t/0 wrapping the Membrane.RCMessage.EndOfStream.t/0 message with no further constraints, sent by the process with pipeline pid. It is required to firstly use the subscribe/2 to subscribe to a given message before awaiting for that message. Usage example: awaiting for the first end_of_stream occuring on any pad of any element in the pipeline: Pipeline . await_end_of_stream ( pipeline )","ref":"Membrane.RCPipeline.html#await_end_of_stream/1","title":"Membrane.RCPipeline.await_end_of_stream/1","type":"function"},{"doc":"Awaits for the first Membrane.RCMessage.t/0 wrapping the Membrane.RCMessage.EndOfStream.t/0 message concerning the given element , sent by the process with pipeline pid. It is required to firstly use the subscribe/2 to subscribe to a given message before awaiting for that message. Usage example: awaiting for the first end_of_stream occuring on any pad of the :element_id element in the pipeline: Pipeline . await_end_of_stream ( pipeline , :element_id )","ref":"Membrane.RCPipeline.html#await_end_of_stream/2","title":"Membrane.RCPipeline.await_end_of_stream/2","type":"function"},{"doc":"Awaits for the first Membrane.RCMessage.t/0 wrapping the Membrane.RCMessage.EndOfStream.t/0 message concerning the given element and the pad , sent by the process with pipeline pid. It is required to firstly use the subscribe/2 to subscribe to a given message before awaiting for that message. Usage example: awaiting for the first end_of_stream occuring on the :pad_id of the :element_id element in the pipeline: Pipeline . await_end_of_stream ( pipeline , :element_id , :pad_id )","ref":"Membrane.RCPipeline.html#await_end_of_stream/3","title":"Membrane.RCPipeline.await_end_of_stream/3","type":"function"},{"doc":"Awaits for the first Membrane.RCMessage.t/0 wrapping the Membrane.RCMessage.Notification.t/0 message with no further constraints, sent by the process with pipeline pid. It is required to firstly use the subscribe/2 to subscribe to a given message before awaiting for that message. Usage example: awaiting for the first notification send to any element in the pipeline: Pipeline . await_notification ( pipeline )","ref":"Membrane.RCPipeline.html#await_notification/1","title":"Membrane.RCPipeline.await_notification/1","type":"function"},{"doc":"Awaits for the first Membrane.RCMessage.t/0 wrapping the Membrane.RCMessage.Notification.t/0 message concerning the given element , sent by the process with pipeline pid. It is required to firstly use the subscribe/2 to subscribe to a given message before awaiting for that message. Usage example: awaiting for the first notification send to the :element_id element in the pipeline: Pipeline . await_notification ( pipeline , :element_id )","ref":"Membrane.RCPipeline.html#await_notification/2","title":"Membrane.RCPipeline.await_notification/2","type":"function"},{"doc":"Awaits for the first Membrane.RCMessage.t/0 wrapping the Membrane.RCMessage.Playing.t/0 It is required to firstly use the subscribe/2 to subscribe to a given message before awaiting for that message. Usage example: awaiting until the pipeline starts playing: Pipeline . await_playing ( pipeline )","ref":"Membrane.RCPipeline.html#await_playing/1","title":"Membrane.RCPipeline.await_playing/1","type":"function"},{"doc":"Awaits for the first Membrane.RCMessage.t/0 wrapping the Membrane.RCMessage.StartOfStream.t/0 message with no further constraints, sent by the process with pipeline pid. It is required to firstly use the subscribe/2 to subscribe to a given message before awaiting for that message. Usage example: awaiting for the first start_of_stream occuring on any pad of any element in the pipeline: Pipeline . await_start_of_stream ( pipeline )","ref":"Membrane.RCPipeline.html#await_start_of_stream/1","title":"Membrane.RCPipeline.await_start_of_stream/1","type":"function"},{"doc":"Awaits for the first Membrane.RCMessage.t/0 wrapping the Membrane.RCMessage.StartOfStream.t/0 message concerning the given element , sent by the process with pipeline pid. It is required to firstly use the subscribe/2 to subscribe to a given message before awaiting for that message. Usage example: awaiting for the first start_of_stream occuring on any pad of the :element_id element in the pipeline: Pipeline . await_start_of_stream ( pipeline , :element_id )","ref":"Membrane.RCPipeline.html#await_start_of_stream/2","title":"Membrane.RCPipeline.await_start_of_stream/2","type":"function"},{"doc":"Awaits for the first Membrane.RCMessage.t/0 wrapping the Membrane.RCMessage.StartOfStream.t/0 message concerning the given element and the pad , sent by the process with pipeline pid. It is required to firstly use the subscribe/2 to subscribe to a given message before awaiting for that message. Usage example: awaiting for the first start_of_stream occuring on the :pad_id pad of the :element_id element in the pipeline: Pipeline . await_start_of_stream ( pipeline , :element_id , :pad_id )","ref":"Membrane.RCPipeline.html#await_start_of_stream/3","title":"Membrane.RCPipeline.await_start_of_stream/3","type":"function"},{"doc":"Awaits for the Membrane.RCMessage.t/0 wrapping the Membrane.RCMessage.Terminated message, which is send when the pipeline gracefully terminates. It is required to firstly use the subscribe/2 to subscribe to a given message before awaiting for that message. Usage example: awaiting for the pipeline termination: Pipeline . await_termination ( pipeline )","ref":"Membrane.RCPipeline.html#await_termination/1","title":"Membrane.RCPipeline.await_termination/1","type":"function"},{"doc":"Returns child specification for spawning under a supervisor","ref":"Membrane.RCPipeline.html#child_spec/1","title":"Membrane.RCPipeline.child_spec/1","type":"function"},{"doc":"Sends a list of t:Pipeline.Action.t/0 to the given Membrane.RCPipeline for execution. Usage example: making the Membrane.RCPipeline start the Membrane.ChildrenSpec specified in the action. children = ... links = ... actions = [ { :spec , children ++ links } ] Pipeline . exec_actions ( pipeline , actions )","ref":"Membrane.RCPipeline.html#exec_actions/2","title":"Membrane.RCPipeline.exec_actions/2","type":"function"},{"doc":"Does the same as the start_link/1 but starts the process outside of the current supervision tree.","ref":"Membrane.RCPipeline.html#start/1","title":"Membrane.RCPipeline.start/1","type":"function"},{"doc":"","ref":"Membrane.RCPipeline.html#start!/1","title":"Membrane.RCPipeline.start!/1","type":"function"},{"doc":"Starts the Membrane.RCPipeline and links it to the current process. The process that makes the call to the start_link/1 automatically becomes the controller process.","ref":"Membrane.RCPipeline.html#start_link/1","title":"Membrane.RCPipeline.start_link/1","type":"function"},{"doc":"","ref":"Membrane.RCPipeline.html#start_link!/1","title":"Membrane.RCPipeline.start_link!/1","type":"function"},{"doc":"Subscribes to a given subscription_pattern . The subscription_pattern should describe some subset of elements of t:Membrane.RCPipeline.Message.t/0 type. The subscription_pattern must be a match pattern. Usage examples: making the Membrane.RCPipeline send to the controlling process Message.StartOfStream message when any pad of the :element_id receives :start_of_stream event. subscribe ( pipeline , % Message.StartOfStream { element : :element_id , pad : _ } ) making the Membrane.RCPipeline send to the controlling process Message.Playing message when the pipeline playback changes to :playing subscribe ( pipeline , % Message.Playing { } )","ref":"Membrane.RCPipeline.html#subscribe/2","title":"Membrane.RCPipeline.subscribe/2","type":"macro"},{"doc":"Changes pipeline's playback to :stopped and terminates its process.","ref":"Membrane.RCPipeline.html#terminate/2","title":"Membrane.RCPipeline.terminate/2","type":"function"},{"doc":"Message sent when some element of the pipeline receives the start of stream event on some pad.","ref":"Membrane.RCMessage.EndOfStream.html","title":"Membrane.RCMessage.EndOfStream","type":"module"},{"doc":"Message sent when some element of the pipeline receives the start of stream event on some pad.","ref":"Membrane.RCMessage.EndOfStream.html#t:t/0","title":"Membrane.RCMessage.EndOfStream.t/0","type":"type"},{"doc":"Message sent when the some element of the pipeline receives a notification.","ref":"Membrane.RCMessage.Notification.html","title":"Membrane.RCMessage.Notification","type":"module"},{"doc":"Message sent when the some element of the pipeline receives a notification.","ref":"Membrane.RCMessage.Notification.html#t:t/0","title":"Membrane.RCMessage.Notification.t/0","type":"type"},{"doc":"Message sent when the pipeline starts playing","ref":"Membrane.RCMessage.Playing.html","title":"Membrane.RCMessage.Playing","type":"module"},{"doc":"Message sent when the pipeline starts playing","ref":"Membrane.RCMessage.Playing.html#t:t/0","title":"Membrane.RCMessage.Playing.t/0","type":"type"},{"doc":"Message sent when some element of the pipeline receives the start of stream event on some pad.","ref":"Membrane.RCMessage.StartOfStream.html","title":"Membrane.RCMessage.StartOfStream","type":"module"},{"doc":"Message sent when some element of the pipeline receives the start of stream event on some pad.","ref":"Membrane.RCMessage.StartOfStream.html#t:t/0","title":"Membrane.RCMessage.StartOfStream.t/0","type":"type"},{"doc":"Message sent when the pipeline gracefully terminates.","ref":"Membrane.RCMessage.Terminated.html","title":"Membrane.RCMessage.Terminated","type":"module"},{"doc":"Message sent when the pipeline gracefully terminates.","ref":"Membrane.RCMessage.Terminated.html#t:t/0","title":"Membrane.RCMessage.Terminated.t/0","type":"type"},{"doc":"Bins, similarly to pipelines, are containers for elements. However, at the same time, they can be placed and linked within pipelines. Although bin is a separate Membrane entity, it can be perceived as a pipeline within an element. Bins can also be nested within one another. There are two main reasons why bins are useful: they enable creating reusable element groups they allow managing their children, for instance by dynamically spawning or replacing them as the stream changes. In order to create bin use Membrane.Bin in your callback module.","ref":"Membrane.Bin.html","title":"Membrane.Bin","type":"behaviour"},{"doc":"Brings all the stuff necessary to implement a bin. Options: :bring_spec? - if true (default) imports and aliases Membrane.ChildrenSpec :bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Bin.html#__using__/1","title":"Membrane.Bin.__using__/1","type":"macro"},{"doc":"Checks whether module is a bin.","ref":"Membrane.Bin.html#bin?/1","title":"Membrane.Bin.bin?/1","type":"function"},{"doc":"Defines that bin exposes a clock which is a proxy to one of its children. If this macro is not called, no ticks will be forwarded to parent, regardless of clock definitions in its children.","ref":"Membrane.Bin.html#def_clock/1","title":"Membrane.Bin.def_clock/1","type":"macro"},{"doc":"Macro that defines input pad for the bin. It automatically generates documentation from the given definition and adds compile-time stream format specs validation. The type Membrane.Pad.bin_spec/0 describes how the definition of pads should look.","ref":"Membrane.Bin.html#def_input_pad/2","title":"Membrane.Bin.def_input_pad/2","type":"macro"},{"doc":"Macro defining options that parametrize bin. It automatically generates appropriate struct and documentation. Options are defined by a keyword list, where each key is an option name and is described by another keyword list with following fields: spec: typespec for value in struct default: default value for option. If not present, value for this option will have to be provided each time options struct is created inspector: function converting fields' value to a string. Used when creating documentation instead of inspect/1 , e.g. inspector: &amp;Membrane.Time.inspect/1 description: string describing an option. It will be used for generating the docs","ref":"Membrane.Bin.html#def_options/1","title":"Membrane.Bin.def_options/1","type":"macro"},{"doc":"Macro that defines output pad for the bin. It automatically generates documentation from the given definition and adds compile-time stream format specs validation. The type Membrane.Pad.bin_spec/0 describes how the definition of pads should look.","ref":"Membrane.Bin.html#def_output_pad/2","title":"Membrane.Bin.def_output_pad/2","type":"macro"},{"doc":"Callback invoked when a notification comes in from an element.","ref":"Membrane.Bin.html#c:handle_child_notification/4","title":"Membrane.Bin.handle_child_notification/4","type":"callback"},{"doc":"Callback invoked when a child removes its pad. The callback won't be invoked, when you have initiated the pad removal, e.g. when you have returned t:Membrane.Bin.Action.remove_link() action which made one of your children's pads be removed.","ref":"Membrane.Bin.html#c:handle_child_pad_removed/4","title":"Membrane.Bin.handle_child_pad_removed/4","type":"callback"},{"doc":"Callback invoked when crash of the crash group happens. Context passed to this callback contains 2 additional fields: :members and :crash_initiator .","ref":"Membrane.Bin.html#c:handle_crash_group_down/3","title":"Membrane.Bin.handle_crash_group_down/3","type":"callback"},{"doc":"Callback invoked when a child element finishes processing stream via given pad.","ref":"Membrane.Bin.html#c:handle_element_end_of_stream/4","title":"Membrane.Bin.handle_element_end_of_stream/4","type":"callback"},{"doc":"Callback invoked when a child element starts processing stream via given pad.","ref":"Membrane.Bin.html#c:handle_element_start_of_stream/4","title":"Membrane.Bin.handle_element_start_of_stream/4","type":"callback"},{"doc":"Callback invoked when bin receives a message that is not recognized as an internal membrane message. Can be used for receiving data from non-membrane processes.","ref":"Membrane.Bin.html#c:handle_info/3","title":"Membrane.Bin.handle_info/3","type":"callback"},{"doc":"Callback invoked on initialization of bin. This callback is synchronous: the parent waits until it finishes. Also, any failures that happen in this callback crash the parent as well, regardless of crash groups. For these reasons, it's important to do any long-lasting or complex work in handle_setup/2 , while handle_init should be used for things like parsing options, initializing state or spawning children.","ref":"Membrane.Bin.html#c:handle_init/2","title":"Membrane.Bin.handle_init/2","type":"callback"},{"doc":"Callback that is called when new pad has been added to bin. Executed ONLY for dynamic pads. Context passed to this callback contains additional field :options .","ref":"Membrane.Bin.html#c:handle_pad_added/3","title":"Membrane.Bin.handle_pad_added/3","type":"callback"},{"doc":"Callback that is called when some pad of the bin has been removed. Executed ONLY for dynamic pads. Context passed to this callback contains additional field :options .","ref":"Membrane.Bin.html#c:handle_pad_removed/3","title":"Membrane.Bin.handle_pad_removed/3","type":"callback"},{"doc":"Callback invoked when a notification comes in from an parent.","ref":"Membrane.Bin.html#c:handle_parent_notification/3","title":"Membrane.Bin.handle_parent_notification/3","type":"callback"},{"doc":"Callback invoked when bin switches the playback to :playing .","ref":"Membrane.Bin.html#c:handle_playing/2","title":"Membrane.Bin.handle_playing/2","type":"callback"},{"doc":"Callback invoked on bin startup, right after handle_init/2 . Any long-lasting or complex initialization should happen here.","ref":"Membrane.Bin.html#c:handle_setup/2","title":"Membrane.Bin.handle_setup/2","type":"callback"},{"doc":"Callback invoked when children of Membrane.ChildrenSpec are started.","ref":"Membrane.Bin.html#c:handle_spec_started/3","title":"Membrane.Bin.handle_spec_started/3","type":"callback"},{"doc":"A callback invoked when the bin is being removed by its parent. By default it returns Membrane.Bin.Action.terminate/0 with reason :normal .","ref":"Membrane.Bin.html#c:handle_terminate_request/2","title":"Membrane.Bin.handle_terminate_request/2","type":"callback"},{"doc":"Callback invoked upon each timer tick. A timer can be started with Membrane.Bin.Action.start_timer/0 action.","ref":"Membrane.Bin.html#c:handle_tick/3","title":"Membrane.Bin.handle_tick/3","type":"callback"},{"doc":"","ref":"Membrane.Bin.html#is_bin_name?/1","title":"Membrane.Bin.is_bin_name?/1","type":"macro"},{"doc":"","ref":"Membrane.Bin.html#t:callback_return/0","title":"Membrane.Bin.callback_return/0","type":"type"},{"doc":"Type that defines a bin name by which it is identified.","ref":"Membrane.Bin.html#t:name/0","title":"Membrane.Bin.name/0","type":"type"},{"doc":"Defines options that can be passed to start_link/3 and received in handle_init/2 callback.","ref":"Membrane.Bin.html#t:options/0","title":"Membrane.Bin.options/0","type":"type"},{"doc":"","ref":"Membrane.Bin.html#t:state/0","title":"Membrane.Bin.state/0","type":"type"},{"doc":"This module contains type specifications of actions that can be returned from bin callbacks. Returning actions is a way of bin interaction with other components and parts of framework. Each action may be returned by any callback unless explicitly stated otherwise.","ref":"Membrane.Bin.Action.html","title":"Membrane.Bin.Action","type":"module"},{"doc":"Action that sends a message to a child identified by name.","ref":"Membrane.Bin.Action.html#t:notify_child/0","title":"Membrane.Bin.Action.notify_child/0","type":"type"},{"doc":"Sends a message to the parent.","ref":"Membrane.Bin.Action.html#t:notify_parent/0","title":"Membrane.Bin.Action.notify_parent/0","type":"type"},{"doc":"","ref":"Membrane.Bin.Action.html#t:remove_child/0","title":"Membrane.Bin.Action.remove_child/0","type":"type"},{"doc":"Action that stops, unlinks and removes specified child/children from the bin. A child ref, list of children refs, children group id or a list of children group ids can be specified as an argument.","ref":"Membrane.Bin.Action.html#t:remove_children/0","title":"Membrane.Bin.Action.remove_children/0","type":"type"},{"doc":"Action that removes link, which relates to specified child and pad. Removed link has to have dynamic pads on both ends.","ref":"Membrane.Bin.Action.html#t:remove_link/0","title":"Membrane.Bin.Action.remove_link/0","type":"type"},{"doc":"Action that manages the end of the component setup. By default, component setup ends with the end of Membrane.Bin.handle_setup/2 callback. If {:setup, :incomplete} is returned there, setup lasts until {:setup, :complete} is returned from antoher callback. Untils the setup lasts, the component won't enter :playing playback.","ref":"Membrane.Bin.Action.html#t:setup/0","title":"Membrane.Bin.Action.setup/0","type":"type"},{"doc":"Action that instantiates children and links them according to Membrane.ChildrenSpec . Children's playback is changed to the current bin playback. c:Membrane.Parent.handle_spec_started/3 callback is executed once the children are spawned.","ref":"Membrane.Bin.Action.html#t:spec/0","title":"Membrane.Bin.Action.spec/0","type":"type"},{"doc":"Starts a timer that will invoke Membrane.Bin.handle_tick/3 callback every interval according to the given clock . The timer's id is passed to the Membrane.Bin.handle_tick/3 callback and can be used for changing its interval via timer_interval/0 or stopping it via stop_timer/0 . If interval is set to :no_interval , the timer won't issue any ticks until the interval is set with timer_interval/0 action. If no clock is passed, parent clock is chosen. Timers use Process.send_after/3 under the hood.","ref":"Membrane.Bin.Action.html#t:start_timer/0","title":"Membrane.Bin.Action.start_timer/0","type":"type"},{"doc":"Stops a timer started with start_timer/0 action. This action is atomic: stopping timer guarantees that no ticks will arrive from it.","ref":"Membrane.Bin.Action.html#t:stop_timer/0","title":"Membrane.Bin.Action.stop_timer/0","type":"type"},{"doc":"Type describing actions that can be returned from bin callbacks. Returning actions is a way of bin interaction with its children and other parts of framework.","ref":"Membrane.Bin.Action.html#t:t/0","title":"Membrane.Bin.Action.t/0","type":"type"},{"doc":"Terminates bin with given reason. Termination reason follows the OTP semantics: Use :normal for graceful termination. Allowed only when the parent already requested termination, i.e. after Membrane.Bin.handle_terminate_request/2 is called. If the bin has no children, it terminates immediately. Otherwise, it switches to the zombie mode, requests all the children to terminate, waits for them to terminate and then terminates itself. In the zombie mode, no bin callbacks are called and all messages and calls to the bin are ignored (apart from Membrane internal messages) If the reason is other than :normal , the bin terminates immediately. The bin supervisor terminates all the children with the reason :shutdown If the reason is neither :normal , :shutdown nor {:shutdown, term} , an error is logged","ref":"Membrane.Bin.Action.html#t:terminate/0","title":"Membrane.Bin.Action.terminate/0","type":"type"},{"doc":"Changes interval of a timer started with start_timer/0 . Permitted only from Membrane.Bin.handle_tick/3 , unless the interval was previously set to :no_interval . If the interval is :no_interval , the timer won't issue any ticks until another timer_interval/0 action. Otherwise, the timer will issue ticks every new interval . The next tick after interval change is scheduled at new_interval + previous_time , where previous_time is the time of the latest tick or the time of returning start_timer/0 action if no tick has been sent yet. Note that if current_time - previous_time &gt; new_interval , a burst of div(current_time - previous_time, new_interval) ticks is issued immediately.","ref":"Membrane.Bin.Action.html#t:timer_interval/0","title":"Membrane.Bin.Action.timer_interval/0","type":"type"},{"doc":"Module describing context passed to the Membrane.Bin callbacks.","ref":"Membrane.Bin.CallbackContext.html","title":"Membrane.Bin.CallbackContext","type":"module"},{"doc":"Type describing context passed to the Membrane.Bin callbacks. Field :options is present only in Membrane.Bin.handle_pad_added/3 and Membrane.Bin.handle_pad_removed/3 . Fields :members and :crash_initiator are present only in Membrane.Pipeline.handle_crash_group_down/3 .","ref":"Membrane.Bin.CallbackContext.html#t:t/0","title":"Membrane.Bin.CallbackContext.t/0","type":"type"},{"doc":"Struct describing current pad state. The public fields are: :availability - see Membrane.Pad.availability/0 :direction - see Membrane.Pad.direction/0 :name - see Membrane.Pad.name/0 . Do not mistake with :ref :options - options passed in Membrane.ChildrenSpec when linking pad :ref - see Membrane.Pad.ref/0 Other fields in the struct ARE NOT PART OF THE PUBLIC API and should not be accessed or relied on.","ref":"Membrane.Bin.PadData.html","title":"Membrane.Bin.PadData","type":"module"},{"doc":"","ref":"Membrane.Bin.PadData.html#t:private_field/0","title":"Membrane.Bin.PadData.private_field/0","type":"type"},{"doc":"Struct describing current pad state. The public fields are: :availability - see Membrane.Pad.availability/0 :direction - see Membrane.Pad.direction/0 :name - see Membrane.Pad.name/0 . Do not mistake with :ref :options - options passed in Membrane.ChildrenSpec when linking pad :ref - see Membrane.Pad.ref/0 Other fields in the struct ARE NOT PART OF THE PUBLIC API and should not be accessed or relied on.","ref":"Membrane.Bin.PadData.html#t:t/0","title":"Membrane.Bin.PadData.t/0","type":"type"},{"doc":"Module containing types and functions for operating on elements. For behaviours for elements check Membrane.Source , Membrane.Filter , Membrane.Endpoint and Membrane.Sink . Behaviours Element-specific behaviours are specified in modules: Membrane.Element.WithOutputPads - behaviour common to sources, filters and endpoints Membrane.Element.WithInputPads - behaviour common to sinks, filters and endpoints Base modules ( Membrane.Source , Membrane.Filter , Membrane.Endpoint , Membrane.Sink ) - behaviours specific to each element type. Callbacks Modules listed above provide specifications of callbacks that define elements lifecycle. All of these callbacks have names with the handle_ prefix. They are used to define reaction to certain events that happen during runtime, and indicate what actions framework should undertake as a result, besides executing element-specific code. For actions that can be returned by each callback, see Membrane.Element.Action module.","ref":"Membrane.Element.html","title":"Membrane.Element","type":"module"},{"doc":"Checks whether module is an element.","ref":"Membrane.Element.html#element?/1","title":"Membrane.Element.element?/1","type":"function"},{"doc":"","ref":"Membrane.Element.html#is_element_name?/1","title":"Membrane.Element.is_element_name?/1","type":"macro"},{"doc":"Type that defines an element name by which it is identified.","ref":"Membrane.Element.html#t:name/0","title":"Membrane.Element.name/0","type":"type"},{"doc":"Defines options that can be received in Membrane.Element.Base.handle_init/2 callback.","ref":"Membrane.Element.html#t:options/0","title":"Membrane.Element.options/0","type":"type"},{"doc":"Type of user-managed state of element.","ref":"Membrane.Element.html#t:state/0","title":"Membrane.Element.state/0","type":"type"},{"doc":"Defines possible element types: source, producing buffers filter, processing buffers endpoint, producing and consuming buffers sink, consuming buffers","ref":"Membrane.Element.html#t:type/0","title":"Membrane.Element.type/0","type":"type"},{"doc":"Module defining behaviour for endpoints - elements consuming and producing data. Behaviours for endpoints are specified, besides this place, in modules Membrane.Element.Base , Membrane.Element.WithOutputPads , and Membrane.Element.WithInputPads . Endpoint can have both input and output pads. Job of usual endpoint is both, to receive some data on such pad and consume it (write to a soundcard, send through TCP etc.) and to produce some data (read from soundcard, download through HTTP, etc.) and send it through such pad. If the pad has the flow control set to :manual , then endpoint is also responsible for receiving demands on the output pad and requesting them on the input pad (for more details, see Membrane.Element.WithOutputPads.handle_demand/5 callback). Endpoints, like all elements, can of course have multiple pads if needed to provide more complex solutions. List of available callbacks Below there is a list of all the callbacks available in a module, that implements Membrane.Endpoint behaviour. We have put it for your convenience, as some of these callbacks aren't directly defined in that module and their specification is available in different modules. The callbacks available in Membrane.Endpoint behaviour: Membrane.Element.Base Membrane.Element.Base.__struct__/0 Membrane.Element.Base.__struct__/1 Membrane.Element.Base.handle_event/4 Membrane.Element.Base.handle_info/3 Membrane.Element.Base.handle_init/2 Membrane.Element.Base.handle_pad_added/3 Membrane.Element.Base.handle_pad_removed/3 Membrane.Element.Base.handle_parent_notification/3 Membrane.Element.Base.handle_playing/2 Membrane.Element.Base.handle_setup/2 Membrane.Element.Base.handle_terminate_request/2 Membrane.Element.Base.handle_tick/3 Membrane.Element.WithInputPads Membrane.Element.WithInputPads.handle_buffer/4 Membrane.Element.WithInputPads.handle_buffers_batch/4 Membrane.Element.WithInputPads.handle_end_of_stream/3 Membrane.Element.WithInputPads.handle_process/4 Membrane.Element.WithInputPads.handle_process_list/4 Membrane.Element.WithInputPads.handle_start_of_stream/3 Membrane.Element.WithInputPads.handle_stream_format/4 Membrane.Element.WithInputPads.handle_write/4 Membrane.Element.WithInputPads.handle_write_list/4 Membrane.Element.WithOutputPads Membrane.Element.WithOutputPads.handle_demand/5","ref":"Membrane.Endpoint.html","title":"Membrane.Endpoint","type":"module"},{"doc":"Brings all the stuff necessary to implement a endpoint element. Options: :bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Endpoint.html#__using__/1","title":"Membrane.Endpoint.__using__/1","type":"macro"},{"doc":"Module defining behaviour for filters - elements processing data. Behaviours for filters are specified, besides this place, in modules Membrane.Element.Base , Membrane.Element.WithOutputPads , and Membrane.Element.WithInputPads . Filters can have both input and output pads. Job of a usual filter is to receive some data on a input pad, process the data and send it through the output pad. If the pad has the flow control set to :manual , then filter is also responsible for receiving demands on the output pad and requesting them on the input pad (for more details, see Membrane.Element.WithOutputPads.handle_demand/5 callback). Filters, like all elements, can of course have multiple pads if needed to provide more complex solutions. List of available callbacks Below there is a list of all the callbacks available in a module, that implements Membrane.Filter behaviour. We have put it for your convenience, as some of these callbacks aren't directly defined in that module and their specification is available in different modules. The callbacks available in Membrane.Filter behaviour: Membrane.Element.Base Membrane.Element.Base.__struct__/0 Membrane.Element.Base.__struct__/1 Membrane.Element.Base.handle_event/4 Membrane.Element.Base.handle_info/3 Membrane.Element.Base.handle_init/2 Membrane.Element.Base.handle_pad_added/3 Membrane.Element.Base.handle_pad_removed/3 Membrane.Element.Base.handle_parent_notification/3 Membrane.Element.Base.handle_playing/2 Membrane.Element.Base.handle_setup/2 Membrane.Element.Base.handle_terminate_request/2 Membrane.Element.Base.handle_tick/3 Membrane.Element.WithInputPads Membrane.Element.WithInputPads.handle_buffer/4 Membrane.Element.WithInputPads.handle_buffers_batch/4 Membrane.Element.WithInputPads.handle_end_of_stream/3 Membrane.Element.WithInputPads.handle_process/4 Membrane.Element.WithInputPads.handle_process_list/4 Membrane.Element.WithInputPads.handle_start_of_stream/3 Membrane.Element.WithInputPads.handle_stream_format/4 Membrane.Element.WithInputPads.handle_write/4 Membrane.Element.WithInputPads.handle_write_list/4 Membrane.Element.WithOutputPads Membrane.Element.WithOutputPads.handle_demand/5","ref":"Membrane.Filter.html","title":"Membrane.Filter","type":"module"},{"doc":"Brings all the stuff necessary to implement a filter element. Options: :bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Filter.html#__using__/1","title":"Membrane.Filter.__using__/1","type":"macro"},{"doc":"An element allowing to aggregate many filters within one Elixir process. Warning: This element is still in experimental phase This element supports only filters with one input and one output with following restrictions: not using timers not relying on received messages not expecting any events coming from downstream elements their pads have to be named :input and :output their pads cannot use manual demands the first filter must make demands in buffers Element options Passed via struct Membrane.FilterAggregator.t/0 filters [ { Membrane.Child . name ( ) , module ( ) | struct ( ) } ] Required A list of filters applied to incoming stream Pads :input Accepted formats: _any Direction: :input Availability: :always Flow control: :auto Demand unit: nil :output Accepted formats: _any Direction: :output Availability: :always Flow control: :auto Demand unit: nil","ref":"Membrane.FilterAggregator.html","title":"Membrane.FilterAggregator","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.FilterAggregator.html#options/0","title":"Membrane.FilterAggregator.options/0","type":"function"},{"doc":"Struct containing options for Membrane.FilterAggregator","ref":"Membrane.FilterAggregator.html#t:t/0","title":"Membrane.FilterAggregator.t/0","type":"type"},{"doc":"Module defining behaviour for sinks - elements consuming data. Behaviours for sinks are specified, besides this place, in modules Membrane.Element.Base , and Membrane.Element.WithInputPads . Sink elements can define only input pads. Job of a usual sink is to receive some data on such pad and consume it (write to a soundcard, send through TCP etc.). If the pad has the flow control set to :manual , then element is also responsible for requesting demands when it is able and willing to consume data (for more details, see Membrane.Element.Action.demand/0 ). Sinks, like all elements, can of course have multiple pads if needed to provide more complex solutions. List of available callbacks Below there is a list of all the callbacks available in a module, that implements Membrane.Sink behaviour. We have put it for your convenience, as some of these callbacks aren't directly defined in that module and their specification is available in different modules. The callbacks available in Membrane.Sink behaviour: Membrane.Element.Base Membrane.Element.Base.__struct__/0 Membrane.Element.Base.__struct__/1 Membrane.Element.Base.handle_event/4 Membrane.Element.Base.handle_info/3 Membrane.Element.Base.handle_init/2 Membrane.Element.Base.handle_pad_added/3 Membrane.Element.Base.handle_pad_removed/3 Membrane.Element.Base.handle_parent_notification/3 Membrane.Element.Base.handle_playing/2 Membrane.Element.Base.handle_setup/2 Membrane.Element.Base.handle_terminate_request/2 Membrane.Element.Base.handle_tick/3 Membrane.Element.WithInputPads Membrane.Element.WithInputPads.handle_buffer/4 Membrane.Element.WithInputPads.handle_buffers_batch/4 Membrane.Element.WithInputPads.handle_end_of_stream/3 Membrane.Element.WithInputPads.handle_process/4 Membrane.Element.WithInputPads.handle_process_list/4 Membrane.Element.WithInputPads.handle_start_of_stream/3 Membrane.Element.WithInputPads.handle_stream_format/4 Membrane.Element.WithInputPads.handle_write/4 Membrane.Element.WithInputPads.handle_write_list/4","ref":"Membrane.Sink.html","title":"Membrane.Sink","type":"module"},{"doc":"Brings all the stuff necessary to implement a sink element. Options: :bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Sink.html#__using__/1","title":"Membrane.Sink.__using__/1","type":"macro"},{"doc":"Module that should be used in sources - elements producing data. Declares appropriate behaviours implementation and provides default callbacks implementation. Behaviours for sources are specified in modules Membrane.Element.Base and Membrane.Element.WithOutputPads . Source elements can define only output pads. Job of a usual source is to produce some data (read from soundcard, download through HTTP, etc.) and send it through such pad. If the pad has the flow control set to :manual , then element is also responsible for receiving demands and send buffers only if they have previously been demanded (for more details, see Membrane.Element.WithOutputPads.handle_demand/5 callback). Sources, like all elements, can of course have multiple pads if needed to provide more complex solutions. List of available callbacks Below there is a list of all the callbacks available in a module, that implements Membrane.Source behaviour. We have put it for your convenience, as some of these callbacks aren't directly defined in that module and their specification is available in different modules. The callbacks available in Membrane.Source behaviour: Membrane.Element.Base Membrane.Element.Base.__struct__/0 Membrane.Element.Base.__struct__/1 Membrane.Element.Base.handle_event/4 Membrane.Element.Base.handle_info/3 Membrane.Element.Base.handle_init/2 Membrane.Element.Base.handle_pad_added/3 Membrane.Element.Base.handle_pad_removed/3 Membrane.Element.Base.handle_parent_notification/3 Membrane.Element.Base.handle_playing/2 Membrane.Element.Base.handle_setup/2 Membrane.Element.Base.handle_terminate_request/2 Membrane.Element.Base.handle_tick/3 Membrane.Element.WithOutputPads Membrane.Element.WithOutputPads.handle_demand/5","ref":"Membrane.Source.html","title":"Membrane.Source","type":"module"},{"doc":"Brings all the stuff necessary to implement a source element. Options: :bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Source.html#__using__/1","title":"Membrane.Source.__using__/1","type":"macro"},{"doc":"This module contains type specifications of actions that can be returned from element callbacks. Returning actions is a way of element interaction with other elements and parts of framework. Each action may be returned by any callback unless explicitly stated otherwise.","ref":"Membrane.Element.Action.html","title":"Membrane.Element.Action","type":"module"},{"doc":"Sends buffers through a pad. The pad must have output direction. Allowed only when playback is playing.","ref":"Membrane.Element.Action.html#t:buffer/0","title":"Membrane.Element.Action.buffer/0","type":"type"},{"doc":"Makes a demand on a pad. The pad must have input direction and work in :manual flow control mode. This action does NOT entail sending demand through the pad, but just requesting some amount of data from pad's internal queue, which sends demands automatically when it runs out of data. If there is any data available at the pad, the data is passed to c:Membrane.WithInputPads.handle_buffers_batch/4 callback. Invoked callback is guaranteed not to receive more data than demanded. Demand size can be either a non-negative integer, that overrides existing demand, or a function that is passed current demand, and is to return the new demand. Allowed only when playback is playing.","ref":"Membrane.Element.Action.html#t:demand/0","title":"Membrane.Element.Action.demand/0","type":"type"},{"doc":"","ref":"Membrane.Element.Action.html#t:demand_size/0","title":"Membrane.Element.Action.demand_size/0","type":"type"},{"doc":"Marks that processing via a pad (output) has been finished and the pad instance won't be used anymore. Triggers end_of_stream/3 callback at the receiver element. Allowed only when playback is in playing state.","ref":"Membrane.Element.Action.html#t:end_of_stream/0","title":"Membrane.Element.Action.end_of_stream/0","type":"type"},{"doc":"Sends an event through a pad (input or output). Allowed only when playback is playing .","ref":"Membrane.Element.Action.html#t:event/0","title":"Membrane.Element.Action.event/0","type":"type"},{"doc":"Sends buffers/stream format/event to all output pads of element (or to input pads when event occurs on the output pad). Used by default implementations of Membrane.Element.WithInputPads.handle_stream_format/4 and Membrane.Element.Base.handle_event/4 callbacks in filter. Allowed only when all below conditions are met: element is filter, callback is c:Membrane.WithInputPads.handle_buffers_batch/4 , Membrane.Element.WithInputPads.handle_stream_format/4 or Membrane.Element.Base.handle_event/4 , playback is playing Keep in mind that c:Membrane.WithInputPads.handle_buffers_batch/4 can only forward buffers, Membrane.Element.WithInputPads.handle_stream_format/4 - stream formats and Membrane.Element.Base.handle_event/4 - events.","ref":"Membrane.Element.Action.html#t:forward/0","title":"Membrane.Element.Action.forward/0","type":"type"},{"doc":"This action sets the latency for the element. This action is not premitted in callback Membrane.Element.Base.handle_init/2 .","ref":"Membrane.Element.Action.html#t:latency/0","title":"Membrane.Element.Action.latency/0","type":"type"},{"doc":"Sends a message to the parent.","ref":"Membrane.Element.Action.html#t:notify_parent/0","title":"Membrane.Element.Action.notify_parent/0","type":"type"},{"doc":"Executes Membrane.Element.WithOutputPads.handle_demand/5 callback for the given pad if its demand is greater than 0. The pad must have output direction and work in pull mode. Redemand in Sources and Endpoints In case of Sources and Endpoints, :redemand is just a helper that simplifies element's code. The element doesn't need to generate the whole demand synchronously at handle_demand or store current demand size in its state, but it can just generate one buffer and return :redemand action. If there is still one or more buffers to produce, returning :redemand triggers the next invocation of handle_demand . In such case, the element is to produce next buffer and call :redemand again. If there are no more buffers demanded, handle_demand is not invoked and the loop ends. One more advantage of the approach with :redemand action is that produced buffers are sent one after another in separate messages and this can possibly improve the latency. Redemand in Filters Redemand in Filters is useful in a situation where not the entire demand of output pad has been satisfied and there is a need to send a demand for additional buffers through the input pad. A typical example of this situation is a parser that has not demanded enough bytes to parse the whole frame. Usage limitations Allowed only when playback is playing.","ref":"Membrane.Element.Action.html#t:redemand/0","title":"Membrane.Element.Action.redemand/0","type":"type"},{"doc":"Action that manages the end of the component setup. By default, component setup ends with the end of Membrane.Element.Base.handle_setup/2 callback. If {:setup, :incomplete} is returned there, setup lasts until {:setup, :complete} is returned from antoher callback. Untils the setup lasts, the component won't enter :playing playback.","ref":"Membrane.Element.Action.html#t:setup/0","title":"Membrane.Element.Action.setup/0","type":"type"},{"doc":"Allows to split callback execution into multiple applications of another callback (called from now sub-callback). Executions are synchronous in the element process, and each of them passes subsequent arguments from the args_list, along with the element state (passed as the last argument each time). Return value of each execution of sub-callback can be any valid return value of the original callback (this also means sub-callback can return any action valid for the original callback, unless explicitly stated). Returned actions are executed immediately (they are NOT accumulated and executed after all sub-callback executions are finished). Useful when a long action is to be undertaken, and partial results need to be returned before entire process finishes (e.g. default implementation of c:Membrane.WithInputPads.handle_buffers_batch/4 uses split action to invoke c:Membrane.WithInputPads.handle_buffer/4 with each buffer)","ref":"Membrane.Element.Action.html#t:split/0","title":"Membrane.Element.Action.split/0","type":"type"},{"doc":"Starts a timer that will invoke Membrane.Element.Base.handle_tick/3 callback every interval according to the given clock . The timer's id is passed to the Membrane.Element.Base.handle_tick/3 callback and can be used for changing its interval via timer_interval/0 or stopping it via stop_timer/0 . If interval is set to :no_interval , the timer won't issue any ticks until the interval is set with timer_interval/0 action. If no clock is passed, parent's clock is chosen. Timers use Process.send_after/3 under the hood.","ref":"Membrane.Element.Action.html#t:start_timer/0","title":"Membrane.Element.Action.start_timer/0","type":"type"},{"doc":"Stops a timer started with start_timer/0 action. This action is atomic: stopping timer guarantees that no ticks will arrive from it.","ref":"Membrane.Element.Action.html#t:stop_timer/0","title":"Membrane.Element.Action.stop_timer/0","type":"type"},{"doc":"Sends stream format through a pad. The pad must have output direction. Sent stream format must fit constraints on the pad. Allowed only when playback is playing .","ref":"Membrane.Element.Action.html#t:stream_format/0","title":"Membrane.Element.Action.stream_format/0","type":"type"},{"doc":"Type that defines a single action that may be returned from element callbacks. Depending on element type, callback, current playback and other circumstances there may be different actions available.","ref":"Membrane.Element.Action.html#t:t/0","title":"Membrane.Element.Action.t/0","type":"type"},{"doc":"Terminates element with given reason. Termination reason follows the OTP semantics: Use :normal for graceful termination. Allowed only when the parent already requested termination, i.e. after Membrane.Element.Base.handle_terminate_request/2 is called If reason is neither :normal , :shutdown nor {:shutdown, term} , an error is logged","ref":"Membrane.Element.Action.html#t:terminate/0","title":"Membrane.Element.Action.terminate/0","type":"type"},{"doc":"Changes interval of a timer started with start_timer/0 . Permitted only from Membrane.Element.Base.handle_tick/3 , unless the interval was previously set to :no_interval . If the interval is :no_interval , the timer won't issue any ticks until another timer_interval/0 action. Otherwise, the timer will issue ticks every new interval . The next tick after interval change is scheduled at new_interval + previous_time , where previous_time is the time of the latest tick or the time of returning start_timer/0 action if no tick has been sent yet. Note that if current_time - previous_time &gt; new_interval , a burst of div(current_time - previous_time, new_interval) ticks is issued immediately.","ref":"Membrane.Element.Action.html#t:timer_interval/0","title":"Membrane.Element.Action.timer_interval/0","type":"type"},{"doc":"Module defining behaviour common to all elements. When used declares behaviour implementation, provides default callback definitions and imports macros. Elements Elements are units that produce, process or consume data. They can be linked with Membrane.Pipeline , and thus form a pipeline able to perform complex data processing. Each element defines a set of pads, through which it can be linked with other elements. During playback, pads can either send (output pads) or receive (input pads) data. For more information on pads, see Membrane.Pad . Note: This module ( Membrane.Element.Base ) should not be use d directly. To implement an element, one of the following base modules ( Membrane.Source , Membrane.Filter , Membrane.Endpoint or Membrane.Sink ) has to be use d, depending on the element type: source, producing buffers (contain only output pads), filter, processing buffers (contain both input and output pads), endpoint, producing and consuming buffers (contain both input and output pads), sink, consuming buffers (contain only input pads). For more information on each element type, check documentation for appropriate base module.","ref":"Membrane.Element.Base.html","title":"Membrane.Element.Base","type":"behaviour"},{"doc":"A callback for constructing struct. Will be defined by def_options/1 if used. See defstruct/1 for a more in-depth description.","ref":"Membrane.Element.Base.html#c:__struct__/0","title":"Membrane.Element.Base.__struct__/0","type":"callback"},{"doc":"A callback for constructing struct with values. Will be defined by def_options/1 if used. See defstruct/1 for a more in-depth description.","ref":"Membrane.Element.Base.html#c:__struct__/1","title":"Membrane.Element.Base.__struct__/1","type":"callback"},{"doc":"Brings common stuff needed to implement an element. Used by Membrane.Source.__using__/1 , Membrane.Filter.__using__/1 , Membrane.Endpoint.__using__/1 and Membrane.Sink.__using__/1 . Options: :bring_pad? - if true (default) requires and aliases Membrane.Pad","ref":"Membrane.Element.Base.html#__using__/1","title":"Membrane.Element.Base.__using__/1","type":"macro"},{"doc":"Defines that element exports a clock to pipeline. Exporting clock allows pipeline to choose it as the pipeline clock, enabling other elements to synchronize with it. Element's clock is accessible via clock field, while pipeline's one - via parent_clock field in callback contexts. Both of them can be used for starting timers.","ref":"Membrane.Element.Base.html#def_clock/1","title":"Membrane.Element.Base.def_clock/1","type":"macro"},{"doc":"Macro defining options that parametrize element. It automatically generates appropriate struct and documentation. Options are defined by a keyword list, where each key is an option name and is described by another keyword list with following fields: spec: typespec for value in struct default: default value for option. If not present, value for this option will have to be provided each time options struct is created inspector: function converting fields' value to a string. Used when creating documentation instead of inspect/1 , e.g. inspector: &amp;Membrane.Time.inspect/1 description: string describing an option. It will be used for generating the docs","ref":"Membrane.Element.Base.html#def_options/1","title":"Membrane.Element.Base.def_options/1","type":"macro"},{"doc":"Callback that is called when event arrives. Events may arrive from both input and output pads. In filters by default event is forwarded to all output and input pads, respectively.","ref":"Membrane.Element.Base.html#c:handle_event/4","title":"Membrane.Element.Base.handle_event/4","type":"callback"},{"doc":"Callback invoked when element receives a message that is not recognized as an internal membrane message. Useful for receiving ticks from timer, data sent from NIFs or other stuff.","ref":"Membrane.Element.Base.html#c:handle_info/3","title":"Membrane.Element.Base.handle_info/3","type":"callback"},{"doc":"Callback invoked on initialization of element. This callback is synchronous: the parent waits until it finishes. Also, any failures that happen in this callback crash the parent as well, regardless of crash groups. For these reasons, it's important to do any long-lasting or complex work in handle_setup/2 , while handle_init should be used for things like parsing options or initializing state.","ref":"Membrane.Element.Base.html#c:handle_init/2","title":"Membrane.Element.Base.handle_init/2","type":"callback"},{"doc":"Callback that is called when new pad has beed added to element. Executed ONLY for dynamic pads. Context passed to this callback contains additional field :options .","ref":"Membrane.Element.Base.html#c:handle_pad_added/3","title":"Membrane.Element.Base.handle_pad_added/3","type":"callback"},{"doc":"Callback that is called when some pad of the element has beed removed. Executed ONLY for dynamic pads. Context passed to this callback contains additional field :options .","ref":"Membrane.Element.Base.html#c:handle_pad_removed/3","title":"Membrane.Element.Base.handle_pad_removed/3","type":"callback"},{"doc":"Callback invoked when a message from the parent is received.","ref":"Membrane.Element.Base.html#c:handle_parent_notification/3","title":"Membrane.Element.Base.handle_parent_notification/3","type":"callback"},{"doc":"Callback invoked when bin switches the playback to :playing . From this point, element can send and receive buffers, events, stream formats and demands through its pads.","ref":"Membrane.Element.Base.html#c:handle_playing/2","title":"Membrane.Element.Base.handle_playing/2","type":"callback"},{"doc":"Callback invoked on element startup, right after handle_init/2 . Any long-lasting or complex initialization should happen here.","ref":"Membrane.Element.Base.html#c:handle_setup/2","title":"Membrane.Element.Base.handle_setup/2","type":"callback"},{"doc":"Callback invoked when element is removed by its parent. By default it returns Membrane.Element.Action.terminate/0 with reason :normal .","ref":"Membrane.Element.Base.html#c:handle_terminate_request/2","title":"Membrane.Element.Base.handle_terminate_request/2","type":"callback"},{"doc":"Callback invoked upon each timer tick. A timer can be started with Membrane.Element.Action.start_timer action.","ref":"Membrane.Element.Base.html#c:handle_tick/3","title":"Membrane.Element.Base.handle_tick/3","type":"callback"},{"doc":"Type that defines all valid return values from most callbacks.","ref":"Membrane.Element.Base.html#t:callback_return/0","title":"Membrane.Element.Base.callback_return/0","type":"type"},{"doc":"Describes context passed to the Membrane Element callbacks.","ref":"Membrane.Element.CallbackContext.html","title":"Membrane.Element.CallbackContext","type":"module"},{"doc":"Type describing context passed to the Membrane Element callbacks. Field :incoming_demand is present only in Membrane.Element.WithOutputPads.handle_demand/5 . Field :options is present only in Membrane.Element.Base.handle_pad_added/3 and Membrane.Element.Base.handle_pad_removed/3 . Field :old_stream_format is present only in Membrane.Element.WithInputPads.handle_stream_format/4 .","ref":"Membrane.Element.CallbackContext.html#t:t/0","title":"Membrane.Element.CallbackContext.t/0","type":"type"},{"doc":"Struct describing current pad state. The public fields are: :availability - see Membrane.Pad.availability/0 :stream_format - the most recent Membrane.StreamFormat.t/0 that have been sent (output) or received (input) on the pad. May be nil if not yet set. :direction - see Membrane.Pad.direction/0 :end_of_stream? - flag determining whether the stream processing via the pad has been finished :flow_control - see Membrane.Pad.flow_control/0 . :name - see Membrane.Pad.name/0 . Do not mistake with :ref :options - options passed in Membrane.ParentSpec when linking pad :ref - see Membrane.Pad.ref/0 :start_of_stream? - flag determining whether the stream processing via the pad has been started Other fields in the struct ARE NOT PART OF THE PUBLIC API and should not be accessed or relied on.","ref":"Membrane.Element.PadData.html","title":"Membrane.Element.PadData","type":"module"},{"doc":"","ref":"Membrane.Element.PadData.html#t:private_field/0","title":"Membrane.Element.PadData.private_field/0","type":"type"},{"doc":"Struct describing current pad state. The public fields are: :availability - see Membrane.Pad.availability/0 :stream_format - the most recent Membrane.StreamFormat.t/0 that have been sent (output) or received (input) on the pad. May be nil if not yet set. :direction - see Membrane.Pad.direction/0 :end_of_stream? - flag determining whether the stream processing via the pad has been finished :flow_control - see Membrane.Pad.flow_control/0 . :name - see Membrane.Pad.name/0 . Do not mistake with :ref :options - options passed in Membrane.ParentSpec when linking pad :ref - see Membrane.Pad.ref/0 :start_of_stream? - flag determining whether the stream processing via the pad has been started Other fields in the struct ARE NOT PART OF THE PUBLIC API and should not be accessed or relied on.","ref":"Membrane.Element.PadData.html#t:t/0","title":"Membrane.Element.PadData.t/0","type":"type"},{"doc":"Module defining behaviour for sink, filter and endpoint elements. When used declares behaviour implementation, provides default callback definitions and imports macros. For more information on implementing elements, see Membrane.Element.Base .","ref":"Membrane.Element.WithInputPads.html","title":"Membrane.Element.WithInputPads","type":"behaviour"},{"doc":"Macro that defines input pad for the element. It automatically generates documentation from the given definition and adds compile-time stream format specs validation. The type Membrane.Pad.element_spec/0 describes how the definition of pads should look.","ref":"Membrane.Element.WithInputPads.html#def_input_pad/2","title":"Membrane.Element.WithInputPads.def_input_pad/2","type":"macro"},{"doc":"Callback that is called when buffer should be processed by the Element. In contrast to handle_buffers_batch/4 , it is passed only a single buffer. Called by default implementation of handle_buffers_batch/4 .","ref":"Membrane.Element.WithInputPads.html#c:handle_buffer/4","title":"Membrane.Element.WithInputPads.handle_buffer/4","type":"callback"},{"doc":"Callback that is called when buffer should be processed by the Element. By default calls handle_buffer/4 for each buffer. For pads in pull mode it is called when buffers have been demanded (by returning :demand action from any callback). For pads in push mode it is invoked when buffers arrive.","ref":"Membrane.Element.WithInputPads.html#c:handle_buffers_batch/4","title":"Membrane.Element.WithInputPads.handle_buffers_batch/4","type":"callback"},{"doc":"Callback invoked when the previous element has finished processing via the pad, and it cannot be used anymore.","ref":"Membrane.Element.WithInputPads.html#c:handle_end_of_stream/3","title":"Membrane.Element.WithInputPads.handle_end_of_stream/3","type":"callback"},{"doc":"","ref":"Membrane.Element.WithInputPads.html#c:handle_process/4","title":"Membrane.Element.WithInputPads.handle_process/4","type":"callback"},{"doc":"","ref":"Membrane.Element.WithInputPads.html#c:handle_process_list/4","title":"Membrane.Element.WithInputPads.handle_process_list/4","type":"callback"},{"doc":"Callback invoked when element receives Membrane.Event.StartOfStream event.","ref":"Membrane.Element.WithInputPads.html#c:handle_start_of_stream/3","title":"Membrane.Element.WithInputPads.handle_start_of_stream/3","type":"callback"},{"doc":"Callback invoked when Element is receiving information about new stream format for given pad. In filters stream format is forwarded through all output pads by default. Context passed to this callback contains additional field :old_stream_format .","ref":"Membrane.Element.WithInputPads.html#c:handle_stream_format/4","title":"Membrane.Element.WithInputPads.handle_stream_format/4","type":"callback"},{"doc":"","ref":"Membrane.Element.WithInputPads.html#c:handle_write/4","title":"Membrane.Element.WithInputPads.handle_write/4","type":"callback"},{"doc":"","ref":"Membrane.Element.WithInputPads.html#c:handle_write_list/4","title":"Membrane.Element.WithInputPads.handle_write_list/4","type":"callback"},{"doc":"Module defining behaviour for source and filter elements. When used declares behaviour implementation, provides default callback definitions and imports macros. For more information on implementing elements, see Membrane.Element.Base .","ref":"Membrane.Element.WithOutputPads.html","title":"Membrane.Element.WithOutputPads","type":"behaviour"},{"doc":"Macro that defines output pad for the element. It automatically generates documentation from the given definition and adds compile-time stream format specs validation. The type Membrane.Pad.element_spec/0 describes how the definition of pads should look.","ref":"Membrane.Element.WithOutputPads.html#def_output_pad/2","title":"Membrane.Element.WithOutputPads.def_output_pad/2","type":"macro"},{"doc":"Callback called when buffers should be emitted by a source, filter or endpoint. It is called only for output pads in the :manual flow control mode, as in their case demand is triggered by the input pad of the subsequent element. In sources and endpoint, appropriate amount of data should be sent here. In filters, this callback should usually return :demand action with size sufficient for supplying incoming demand. This will result in calling c:Membrane.WithInputPads.handle_buffers_batch/4 , which is to supply the demand. If a source or an endpoint is unable to produce enough buffers, or a filter underestimated returned demand, the :redemand action should be used (see Membrane.Element.Action.redemand/0 ). Context passed to this callback contains additional field :incoming_demand .","ref":"Membrane.Element.WithOutputPads.html#c:handle_demand/5","title":"Membrane.Element.WithOutputPads.handle_demand/5","type":"callback"},{"doc":"A module with functionalities that allow to represent a topology of a pipeline/bin. The children specification (commonly referred to as a &quot;children_spec&quot;) is represented by the following type: t/0 . It consists of two parts - a children's specification and the children's specification options. The children's specification describes the desired topology and can be incorporated into a pipeline or a bin by returning Membrane.Pipeline.Action.spec/0 or Membrane.Bin.Action.spec/0 action, respectively. This commonly happens within Membrane.Pipeline.handle_init/2 and Membrane.Bin.handle_init/2 , but can be done in any other callback also. Children's specification The children's specification allows specifying the children that need to be spawned in the action, as well as links between the children (both the children spawned in that action, and already existing children). The children's processes are spawned with the use of child/1 , child/2 , child/3 and child/4 functions. These functions can be used for spawning nodes of a link in an inline manner: spec = [ child ( :source , Source ) |&gt; child ( :filter , % Filter { option : 1 } ) |&gt; child ( :sink , Sink ) ] or just to spawn children processes, without linking the newly created children: spec = [ child ( :source , Source ) , child ( :filter , Filter ) , child ( :sink , Sink ) ] Providing a child name is not necessary - you can spawn an anonymous child if you do not need to refer to that child later on: spec = child ( Source ) |&gt; child ( Filter ) Children created that way will have their automatically generated identifier consisting of a module name and a random unique reference number, so that you will be able to distinguish between anonymous children i.e. in log prints. In case you need to refer to an already existing child (which could be spawned, i.e. in the previous spec action), use get_child/1 and get_child/2 functions, as in the example below: spec = [ get_child ( :already_existing_source ) |&gt; child ( :this_filter_will_be_spawned , Filter ) |&gt; get_child ( :already_existing_sink ) ] The child functions allow specifying :get_if_exists option. It might be helpful when you are not certain if the child with the given name exists, and, therefore, you are unable to choose between get_child and child functions. After setting the get_if_exists: true option in child/3 and child/4 functions you can be sure that in case a child with a given name already exists, you will simply refer to that child instead of respawning it. spec = [ child ( :sink , Sink ) , child ( :sink , Sink , get_if_exists : true ) |&gt; child ( :source , Source ) ] In the example above you can see, that the :sink child is created in the first element of the spec list. In the second element of that list, the get_if_exists: true option is used within child/3 , which will have the same effect as if get_child(:sink) was used. At the same time, if the :sink child wasn't already spawned, it would be created in that link definition. Please note that it makes sense to use :get_if_exists option only with named children. Links between pads via_in/2 and via_out/2 functions allow specifying pads' names and parameters. If pads are not specified, name :input is assumed for inputs and :output for outputs. Sample definition: [ get_child ( :source_a ) |&gt; get_child ( :converter ) |&gt; via_in ( :input_a , target_queue_size : 20 ) |&gt; get_child ( :mixer ) , get_child ( :source_b ) |&gt; via_out ( :custom_output ) |&gt; via_in ( :input_b , options : [ mute : true ] ) |&gt; get_child ( :mixer ) |&gt; via_in ( :input , toilet_capacity : 500 ) |&gt; get_child ( :sink ) ] See the docs for via_in/3 and via_out/3 for details on pad properties that can be set. Links can also contain children's definitions, for example: [ child ( :first_element , % Element.With.Options.Struct { option_a : 42 } ) |&gt; child ( :some_element , Element.Without.Options ) |&gt; get_child ( :element_specified_before ) ] Bins For bin boundaries, there are special links allowed. The user should define links between the bin's input and the first child's input (input-input type) and the last child's output and bin output (output-output type). In this case, bin_input/1 and bin_output/2 should be used. Sample definition: [ bin_input ( ) |&gt; get_child ( :filter1 ) |&gt; get_child ( :filter2 ) |&gt; bin_output ( :custom_output ) ] Dynamic pads In most cases, dynamic pads can be linked the same way as static ones, although in the following situations, an exact pad reference must be passed instead of a name: When that reference is needed later, for example, to handle a notification related to that particular pad instance pad = Pad . ref ( :output , make_ref ( ) ) [ get_child ( :tee ) |&gt; via_out ( pad ) |&gt; get_child ( :sink ) ] When linking dynamic pads of a bin with its children, for example in Membrane.Bin.handle_pad_added/3 @impl true def handle_pad_added ( Pad . ref ( :input , _ ) = pad , _ctx , state ) do spec = [ bin_input ( pad ) |&gt; get_child ( :mixer ) ] { { :ok , spec : spec } , state } end Children's specification options Stream sync :stream_sync field can be used for specifying elements that should start playing at the same moment. An example can be audio and video player sinks. This option accepts either :sinks atom or a list of groups (lists) of elements. Passing :sinks results in synchronizing all sinks in the pipeline, while passing a list of groups of elements synchronizes all elements in each group. It is worth mentioning that to keep the stream synchronized all involved elements need to rely on the same clock. By default, no elements are synchronized. Sample definitions: children = ... { children , stream_sync : [ [ :element1 , :element2 ] , [ :element3 , :element4 ] ] } { children , stream_sync : :sinks } Clock provider A clock provider is an element that exports a clock that should be used as the pipeline clock. The pipeline clock is the default clock used by elements' timers. For more information see Membrane.Element.Base.def_clock/1 . Children groups Children groups allow aggregating the spawned children into easily identifiable groups. With the use of them, it is possible to refer to all the children of the group with a single identifier. Example: spec1 = { links1 , group : :first_children_group } spec2 = { links2 , group : :second_children_group } The children spawned within links1 specification will be put inside :first_children_group , whereas the children spawned within links2 specification will be put inside second_children_group . Later on, the children from a given group can be referred with their group , as in the example below: actions = [ remove_children : :first_children_group ] With the action defined above, all the children from the :first_children_group can be removed at once. Crash groups A crash group is a logical entity that prevents the whole pipeline from crashing when one of components crashes. A crash group is defined with the use of two children specification options: group - which acts as a crash group identifier crash_group_mode - its value specifies the behavior of children in the crash group. Currently, we support only :temporary mode which means that Membrane will not make any attempts to restart crashed child. Adding children to a crash group spec = [ child ( :some_element_1 , % SomeElement { # ... } , child ( :some_element_2 , % SomeElement { # ... } ] spec = { spec , group : group_id , crash_group_mode : :temporary } In the above snippet, we create new children - :some_element_1 and :some_element_2 , we add them to the crash group with id group_id . Crash of :some_element_1 or :some_element_2 propagates only to the rest of the members of the crash group and the pipeline stays alive. Handling crash of a crash group When any of the members of the crash group goes down, the callback: handle_crash_group_down/3 is called. @impl true def handle_crash_group_down ( crash_group_id , ctx , state ) do # do some stuff in reaction to the crash of the group with id crash_group_id end Limitations At this moment crash groups are only useful for elements with dynamic pads. Crash groups work in pipelines and bins as well. Log metadata :log_metadata field can be used to set the Membrane.Logger metadata for all children in the given children specification. Nesting children's specifications The children's specifications can be nested within themselves. Consider the following children's specifications: { [ child ( :a , A ) |&gt; child ( :b , B ) , { child ( :c , C ) , group : :second , crash_group_mode : :temporary } ] , group : :first , crash_group_mode : :temporary , node : some_node } Child :c will be spawned in the :second crash group, while children :a and :b will be spawned in the :first crash group. Furthermore, since the inner children specification does not define the :node option, it will be inherited from the outer children specification. That means that child :c will be spawned on the some_node node, along with children :a and :b .","ref":"Membrane.ChildrenSpec.html","title":"Membrane.ChildrenSpec","type":"module"},{"doc":"Begins a link with a bin's pad. See the Children's specification section of the moduledoc for more information.","ref":"Membrane.ChildrenSpec.html#bin_input/1","title":"Membrane.ChildrenSpec.bin_input/1","type":"function"},{"doc":"Ends a link with a bin's output. See the Children's specification section of the moduledoc for more information.","ref":"Membrane.ChildrenSpec.html#bin_output/2","title":"Membrane.ChildrenSpec.bin_output/2","type":"function"},{"doc":"Used to spawn an anonymous child at the beggining of the link specification. See the Children's specification section of the moduledoc for more information.","ref":"Membrane.ChildrenSpec.html#child/1","title":"Membrane.ChildrenSpec.child/1","type":"function"},{"doc":"Used to spawn a named child at the beggining of the link specification or to spawn an anynomous child. See the Children's specification section of the moduledoc for more information.","ref":"Membrane.ChildrenSpec.html#child/2","title":"Membrane.ChildrenSpec.child/2","type":"function"},{"doc":"Used to spawn a named child or an anonymous child in the middle of the link specification. See the Children's specification section of the moduledoc for more information.","ref":"Membrane.ChildrenSpec.html#child/3","title":"Membrane.ChildrenSpec.child/3","type":"function"},{"doc":"Used to spawn a named child in the middle of a link specification. See the Children's specification section of the moduledoc for more information.","ref":"Membrane.ChildrenSpec.html#child/4","title":"Membrane.ChildrenSpec.child/4","type":"function"},{"doc":"Used to refer to an existing child at a beginning of a link specification. See the Children's specification section of the moduledoc for more information.","ref":"Membrane.ChildrenSpec.html#get_child/1","title":"Membrane.ChildrenSpec.get_child/1","type":"function"},{"doc":"Used to refer to an existing child in a middle of a link specification. See the Children's specification section of the moduledoc for more information.","ref":"Membrane.ChildrenSpec.html#get_child/2","title":"Membrane.ChildrenSpec.get_child/2","type":"function"},{"doc":"Specifies input pad name and properties of the subsequent child. The possible properties are: options - If a pad defines options, they can be passed here as a keyword list. Pad options are documented in moduledoc of each element. See Membrane.Element.WithInputPads.def_input_pad/2 and Membrane.Bin.def_input_pad/2 for information about defining pad options. Additionally, the following properties can be used to adjust the flow control parameters. If set within a bin on an input that connects to the bin input, they will be overridden if set when linking to the bin in its parent. toilet_capacity - Used when a toilet is created, that is for pull input pads (with :auto or :manual flow control), that have push output pads (with :push flow control) linked to them. When a push output produces more buffers than the pull input can consume, the buffers are accumulated in a queue called a toilet. If the toilet size grows above its capacity, it overflows by raising an error. target_queue_size - The size of the queue of the input pad that Membrane will try to maintain. That allows for fulfilling the demands of the element by taking data from the queue while the actual sending of demands is done asynchronously, smoothing the processing. Used only for pads working in :manual flow control mode. See Membrane.Pad.flow_control/0 for more information. min_demand_factor - A factor used to calculate minimal demand ( minimal_demand = target_queue_size * min_demand_factor ). Membrane won't send smaller demand than minimal demand , to reduce demands' overhead. However, the user will always receive as many buffers, as demanded, all excess buffers will be queued internally. Used only for pads working in :manual flow control mode. See Membrane.Pad.flow_control/0 for more info. Defaults to 0.25 (the default may change in the future). auto_demand_size - Size of automatically generated demands. Used only for pads working in :auto flow control mode. See Membrane.Pad.flow_control/0 for more info. throttling_factor - an integer specifying how frequently should a sender update the number of buffers in the Toilet . Defaults to 1, meaning, that the sender will update the toilet with each buffer being sent. Setting that factor for elements, which are running on the same node, does not have an impact of performance. However, once the sending element and the receiving element are put on different nodes, the sender updates the toilet with interprocess messages and setting a bigger throttling_factor can reduce the number of messages in the system. At the same time, setting a greater throttling_factor can result in a toilet overflow being detected later. See the Children's specification section of the moduledoc for more information.","ref":"Membrane.ChildrenSpec.html#via_in/3","title":"Membrane.ChildrenSpec.via_in/3","type":"function"},{"doc":"Specifies output pad name and properties of the preceding child. The possible properties are: options - If a pad defines options, they can be passed here as a keyword list. Pad options are documented in moduledoc of each element. See Membrane.Element.WithOutputPads.def_output_pad/2 and Membrane.Bin.def_output_pad/2 for information about defining pad options. See the Children's specification section of the moduledoc for more information.","ref":"Membrane.ChildrenSpec.html#via_out/3","title":"Membrane.ChildrenSpec.via_out/3","type":"function"},{"doc":"","ref":"Membrane.ChildrenSpec.html#t:builder/0","title":"Membrane.ChildrenSpec.builder/0","type":"opaque"},{"doc":"","ref":"Membrane.ChildrenSpec.html#t:child_definition/0","title":"Membrane.ChildrenSpec.child_definition/0","type":"type"},{"doc":"","ref":"Membrane.ChildrenSpec.html#t:child_options/0","title":"Membrane.ChildrenSpec.child_options/0","type":"type"},{"doc":"","ref":"Membrane.ChildrenSpec.html#t:children_spec_options/0","title":"Membrane.ChildrenSpec.children_spec_options/0","type":"type"},{"doc":"","ref":"Membrane.ChildrenSpec.html#t:crash_group_mode/0","title":"Membrane.ChildrenSpec.crash_group_mode/0","type":"type"},{"doc":"","ref":"Membrane.ChildrenSpec.html#t:pad_options/0","title":"Membrane.ChildrenSpec.pad_options/0","type":"type"},{"doc":"Used to describe the inner topology of the pipeline/bin.","ref":"Membrane.ChildrenSpec.html#t:t/0","title":"Membrane.ChildrenSpec.t/0","type":"type"},{"doc":"Module that keeps track of types used by both elements and bins","ref":"Membrane.Child.html","title":"Membrane.Child","type":"module"},{"doc":"","ref":"Membrane.Child.html#is_child_name?/1","title":"Membrane.Child.is_child_name?/1","type":"macro"},{"doc":"","ref":"Membrane.Child.html#t:group/0","title":"Membrane.Child.group/0","type":"type"},{"doc":"","ref":"Membrane.Child.html#t:name/0","title":"Membrane.Child.name/0","type":"type"},{"doc":"","ref":"Membrane.Child.html#t:options/0","title":"Membrane.Child.options/0","type":"type"},{"doc":"Struct describing child entry of a parent. The public fields are: name - child name module - child module options - options passed to the child component_type - either :element or :bin Other fields in the struct ARE NOT PART OF THE PUBLIC API and should not be accessed or relied on.","ref":"Membrane.ChildEntry.html","title":"Membrane.ChildEntry","type":"module"},{"doc":"Struct describing child entry of a parent. The public fields are: name - child name module - child module options - options passed to the child component_type - either :element or :bin Other fields in the struct ARE NOT PART OF THE PUBLIC API and should not be accessed or relied on.","ref":"Membrane.ChildEntry.html#t:t/0","title":"Membrane.ChildEntry.t/0","type":"type"},{"doc":"Structure representing a single chunk of data that flows between elements. For now, it is just a wrapper around bitstring with optionally some metadata attached to it, but in future releases we plan to support different payload types.","ref":"Membrane.Buffer.html","title":"Membrane.Buffer","type":"module"},{"doc":"Returns Membrane.Buffer.t/0 :dts if available or :pts if :dts is not set. If none of them is set nil is returned.","ref":"Membrane.Buffer.html#get_dts_or_pts/1","title":"Membrane.Buffer.get_dts_or_pts/1","type":"function"},{"doc":"","ref":"Membrane.Buffer.html#t:metadata/0","title":"Membrane.Buffer.metadata/0","type":"type"},{"doc":"Structure representing a single chunk of data that flows between elements. For now, it is just a wrapper around bitstring with optionally some metadata attached to it, but in future releases we plan to support different payload types.","ref":"Membrane.Buffer.html#t:t/0","title":"Membrane.Buffer.t/0","type":"type"},{"doc":"A child notification is a message sent from Membrane.Element or Membrane.Bin to a parent via action t:Membrane.Element.Action.notify_parent or t:Membrane.Bin.Action.notify_parent returned from any callback. A notification can be handled in parent with c:Membrane.Parent.handle_child_notification/4 callback.","ref":"Membrane.ChildNotification.html","title":"Membrane.ChildNotification","type":"module"},{"doc":"A child notification is a message sent from Membrane.Element or Membrane.Bin to a parent via action t:Membrane.Element.Action.notify_parent or t:Membrane.Bin.Action.notify_parent returned from any callback. A notification can be handled in parent with c:Membrane.Parent.handle_child_notification/4 callback.","ref":"Membrane.ChildNotification.html#t:t/0","title":"Membrane.ChildNotification.t/0","type":"type"},{"doc":"Event is an entity that can be sent between elements. Events can flow either downstream or upstream - they can be sent with Membrane.Element.Action.event/0 , and can be handled in Membrane.Element.Base.handle_event/4 . Each event is to implement Membrane.EventProtocol , which allows to configure its behaviour.","ref":"Membrane.Event.html","title":"Membrane.Event","type":"module"},{"doc":"See Membrane.EventProtocol.async?/1 .","ref":"Membrane.Event.html#async?/1","title":"Membrane.Event.async?/1","type":"function"},{"doc":"","ref":"Membrane.Event.html#event?/1","title":"Membrane.Event.event?/1","type":"function"},{"doc":"See Membrane.EventProtocol.sticky?/1 .","ref":"Membrane.Event.html#sticky?/1","title":"Membrane.Event.sticky?/1","type":"function"},{"doc":"Event is an entity that can be sent between elements. Events can flow either downstream or upstream - they can be sent with Membrane.Element.Action.event/0 , and can be handled in Membrane.Element.Base.handle_event/4 . Each event is to implement Membrane.EventProtocol , which allows to configure its behaviour.","ref":"Membrane.Event.html#t:t/0","title":"Membrane.Event.t/0","type":"type"},{"doc":"Protocol that allows to configure behaviour of Membrane.Event s. Each event has to implement or derive this protocol.","ref":"Membrane.EventProtocol.html","title":"Membrane.EventProtocol","type":"protocol"},{"doc":"Determines whether event is synchronized with buffers (sync) or not (async). Defaults to false (sync). Buffers and sync events are always received in the same order they are sent. Async events are handled before any buffers enqueued that are waiting in Membrane internal queues to be processed.","ref":"Membrane.EventProtocol.html#async?/1","title":"Membrane.EventProtocol.async?/1","type":"function"},{"doc":"Specifies whether event is sent right away (not sticky), or it is 'pushed' by the next sent buffer (sticky). Defaults to false (not sticky). Returning a sticky event from a callback stores it in a queue. When the next buffer is to be sent, all events from the queue are sent before it. An example can be the Membrane.Event.StartOfStream event.","ref":"Membrane.EventProtocol.html#sticky?/1","title":"Membrane.EventProtocol.sticky?/1","type":"function"},{"doc":"A type describing all the types that implement the Membrane.EventProtocol protocol.","ref":"Membrane.EventProtocol.html#t:t/0","title":"Membrane.EventProtocol.t/0","type":"type"},{"doc":"Generic event for requesting a key frame. The key frame is meant as a part of stream such that the stream can be decoded from the beginning of each key frame without knowledge of the stream content before that point.","ref":"Membrane.KeyframeRequestEvent.html","title":"Membrane.KeyframeRequestEvent","type":"module"},{"doc":"Generic event for requesting a key frame. The key frame is meant as a part of stream such that the stream can be decoded from the beginning of each key frame without knowledge of the stream content before that point.","ref":"Membrane.KeyframeRequestEvent.html#t:t/0","title":"Membrane.KeyframeRequestEvent.t/0","type":"type"},{"doc":"Pads are units defined by elements and bins, allowing them to be linked with their siblings. This module consists of pads typespecs and utils. Each pad is described by its name, direction, availability, mode and possible stream format. For pads to be linkable, these properties have to be compatible. For more information on each of them, check appropriate type in this module. Each link can only consist of exactly two pads.","ref":"Membrane.Pad.html","title":"Membrane.Pad","type":"module"},{"doc":"Returns pad availability mode for given availability.","ref":"Membrane.Pad.html#availability_mode/1","title":"Membrane.Pad.availability_mode/1","type":"function"},{"doc":"","ref":"Membrane.Pad.html#is_availability/1","title":"Membrane.Pad.is_availability/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_availability_dynamic/1","title":"Membrane.Pad.is_availability_dynamic/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_availability_static/1","title":"Membrane.Pad.is_availability_static/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_dynamic_pad_ref/1","title":"Membrane.Pad.is_dynamic_pad_ref/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_pad_name/1","title":"Membrane.Pad.is_pad_name/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_pad_ref/1","title":"Membrane.Pad.is_pad_ref/1","type":"macro"},{"doc":"","ref":"Membrane.Pad.html#is_static_pad_ref/1","title":"Membrane.Pad.is_static_pad_ref/1","type":"macro"},{"doc":"Returns the name for the given pad reference","ref":"Membrane.Pad.html#name_by_ref/1","title":"Membrane.Pad.name_by_ref/1","type":"function"},{"doc":"","ref":"Membrane.Pad.html#opposite_direction/1","title":"Membrane.Pad.opposite_direction/1","type":"function"},{"doc":"Creates a static pad reference.","ref":"Membrane.Pad.html#ref/1","title":"Membrane.Pad.ref/1","type":"macro"},{"doc":"Creates a dynamic pad reference.","ref":"Membrane.Pad.html#ref/2","title":"Membrane.Pad.ref/2","type":"macro"},{"doc":"Describes pattern, that should be matched by stream format send by element on specific pad. Will not be evaluated during runtime, but used for matching struct passed in :stream_format action. Can be a module name, pattern describing struct, or call to any_of function, which arguments are such patterns or modules names. If a module name is passed to the :accepted_format option or is passed to any_of , it will be converted to the match on a struct defined in that module, e.g. accepted_format: My.Format will have this same effect, as accepted_format: %My.Format{} and accepted_format: any_of(My.Format, %My.Another.Format{field: value} when value in [:some, :enumeration]) will have this same effect, as accepted_format: any_of(%My.Format{}, %My.Another.Format{field: value} when value in [:some, :enumeration])","ref":"Membrane.Pad.html#t:accepted_format/0","title":"Membrane.Pad.accepted_format/0","type":"type"},{"doc":"Values used when defining pad availability: :always - a static pad, which can remain unlinked in stopped state only. :on_request - a dynamic pad, instance of which is created every time it is linked to another pad. Thus linking the pad with k other pads, creates k instances of the pad, and links each with another pad.","ref":"Membrane.Pad.html#t:availability/0","title":"Membrane.Pad.availability/0","type":"type"},{"doc":"Type describing availability mode of a created pad: :static - there always exist exactly one instance of such pad. :dynamic - multiple instances of such pad may be created and removed (which entails executing handle_pad_added and handle_pad_removed callbacks, respectively).","ref":"Membrane.Pad.html#t:availability_mode/0","title":"Membrane.Pad.availability_mode/0","type":"type"},{"doc":"Describes how a pad should be declared inside a bin. Demand unit is derived from the first element inside the bin linked to the given input.","ref":"Membrane.Pad.html#t:bin_spec/0","title":"Membrane.Pad.bin_spec/0","type":"type"},{"doc":"Type describing a pad. Contains data parsed from spec/0","ref":"Membrane.Pad.html#t:description/0","title":"Membrane.Pad.description/0","type":"type"},{"doc":"Defines possible pad directions: :output - data can only be sent through such pad, :input - data can only be received through such pad. One cannot link two pads with the same direction.","ref":"Membrane.Pad.html#t:direction/0","title":"Membrane.Pad.direction/0","type":"type"},{"doc":"Possible id of dynamic pad","ref":"Membrane.Pad.html#t:dynamic_id/0","title":"Membrane.Pad.dynamic_id/0","type":"type"},{"doc":"Describes how a pad should be declared inside an element.","ref":"Membrane.Pad.html#t:element_spec/0","title":"Membrane.Pad.element_spec/0","type":"type"},{"doc":"Describes how an element sends and receives data. The available values for that field are: :manual - meaning that the pad works in a pull mode and the demand is manually handled and requested. An element with output :manual pad can send data through such a pad only if it has already received demand on that pad. And element with input :manual pad receives data through such a pad only if it has been previously demanded, so that no undemanded data can arrive For more info, see Membrane.Element.Action.demand , Membrane.Element.Action.redemand and Membrane.Element.WithOutputPads.handle_demand/5 . :auto - meaning that the pad works in a pull mode and the demand is managed automatically: the core ensures that there's demand on each input pad (that has flow_control set to :auto ) whenever there's demand on all output pads (that have flow_control set to :auto ). Currently works for Membrane.Filter s, Membrane.Endpoint s and Membrane.Sink s. :push - meaning that the pad works in a push mode. An element with a :push output pad can send data through that pad whenever it wants. An element with a :push input pad has to deal with data whenever it comes through such a pad - note, that it needs to be done fast enough so that not to let data accumulate, what may lead to overflow of element process erlang queue, which is highly unwanted. Linking pads with different flow control is possible, but only in case of an output pad working in a push mode, and an input pad in pull mode (that is - with :manual or :auto flow control). In such case, however, an error will be raised whenever too many buffers accumulate on the input pad, waiting to be processed.","ref":"Membrane.Pad.html#t:flow_control/0","title":"Membrane.Pad.flow_control/0","type":"type"},{"doc":"Defines the name of pad or group of dynamic pads","ref":"Membrane.Pad.html#t:name/0","title":"Membrane.Pad.name/0","type":"type"},{"doc":"Defines the term by which the pad instance is identified.","ref":"Membrane.Pad.html#t:ref/0","title":"Membrane.Pad.ref/0","type":"type"},{"doc":"Describes how a pad should be declared in element or bin.","ref":"Membrane.Pad.html#t:spec/0","title":"Membrane.Pad.spec/0","type":"type"},{"doc":"A parent notification is a message sent from Membrane.Parent or Membrane.Bin to a child via action t:Membrane.Pipeline.Action.notify_parent or t:Membrane.Bin.Action.notify_child returned from any callback. A notification can be handled in child with Membrane.Element.Base.handle_parent_notification/3 or Membrane.Bin.handle_parent_notification/3 callback.","ref":"Membrane.ParentNotification.html","title":"Membrane.ParentNotification","type":"module"},{"doc":"A parent notification is a message sent from Membrane.Parent or Membrane.Bin to a child via action t:Membrane.Pipeline.Action.notify_parent or t:Membrane.Bin.Action.notify_child returned from any callback. A notification can be handled in child with Membrane.Element.Base.handle_parent_notification/3 or Membrane.Bin.handle_parent_notification/3 callback.","ref":"Membrane.ParentNotification.html#t:t/0","title":"Membrane.ParentNotification.t/0","type":"type"},{"doc":"This protocol describes actions common to all payload types. The most basic payload type is simply a binary for which Elixir.Membrane.Payload is implemented by the Membrane Core.","ref":"Membrane.Payload.html","title":"Membrane.Payload","type":"protocol"},{"doc":"Concatenates the contents of two payloads.","ref":"Membrane.Payload.html#concat/2","title":"Membrane.Payload.concat/2","type":"function"},{"doc":"Drops first n bytes of payload.","ref":"Membrane.Payload.html#drop/2","title":"Membrane.Payload.drop/2","type":"function"},{"doc":"Returns a module responsible for this type of payload and implementing Membrane.Payload.Behaviour","ref":"Membrane.Payload.html#module/1","title":"Membrane.Payload.module/1","type":"function"},{"doc":"Returns total size of payload in bytes","ref":"Membrane.Payload.html#size/1","title":"Membrane.Payload.size/1","type":"function"},{"doc":"Splits the payload at given position (1st part has the size equal to at_pos argument) at_pos has to be greater than 0 and smaller than the size of payload, otherwise an error is raised. This guarantees returned payloads are never empty.","ref":"Membrane.Payload.html#split_at/2","title":"Membrane.Payload.split_at/2","type":"function"},{"doc":"Converts payload into binary","ref":"Membrane.Payload.html#to_binary/1","title":"Membrane.Payload.to_binary/1","type":"function"},{"doc":"A type describing all the types that implement Membrane.Payload protocol.","ref":"Membrane.Payload.html#t:t/0","title":"Membrane.Payload.t/0","type":"type"},{"doc":"Format describing an unparsed data stream. It should be used whenever outputting or accepting an unknown stream (not to be confused with any stream, which can have well-specified format either), or a stream whose format can't/shouldn't be created at that stage. Parameters: :content_format - format that is supposed to be carried in the stream, nil if unknown (default) :type - either :bytestream (continuous stream) or :packetized (each buffer contains exactly one specified unit of data)","ref":"Membrane.RemoteStream.html","title":"Membrane.RemoteStream","type":"module"},{"doc":"Format describing an unparsed data stream. It should be used whenever outputting or accepting an unknown stream (not to be confused with any stream, which can have well-specified format either), or a stream whose format can't/shouldn't be created at that stage. Parameters: :content_format - format that is supposed to be carried in the stream, nil if unknown (default) :type - either :bytestream (continuous stream) or :packetized (each buffer contains exactly one specified unit of data)","ref":"Membrane.RemoteStream.html#t:t/0","title":"Membrane.RemoteStream.t/0","type":"type"},{"doc":"Describes capabilities of some pad. Every pad has some capabilities, which define a type of data that pad is expecting. This format can be, for example, raw audio with specific sample rate or encoded audio in given format. To link two pads together, their capabilities have to be compatible.","ref":"Membrane.StreamFormat.html","title":"Membrane.StreamFormat","type":"module"},{"doc":"Describes capabilities of some pad. Every pad has some capabilities, which define a type of data that pad is expecting. This format can be, for example, raw audio with specific sample rate or encoded audio in given format. To link two pads together, their capabilities have to be compatible.","ref":"Membrane.StreamFormat.html#t:t/0","title":"Membrane.StreamFormat.t/0","type":"type"},{"doc":"Specifies API for metrics that analyze data in terms of a given unit","ref":"Membrane.Buffer.Metric.html","title":"Membrane.Buffer.Metric","type":"behaviour"},{"doc":"","ref":"Membrane.Buffer.Metric.html#c:buffer_size_approximation/0","title":"Membrane.Buffer.Metric.buffer_size_approximation/0","type":"callback"},{"doc":"","ref":"Membrane.Buffer.Metric.html#c:buffers_size/1","title":"Membrane.Buffer.Metric.buffers_size/1","type":"callback"},{"doc":"","ref":"Membrane.Buffer.Metric.html#from_unit/1","title":"Membrane.Buffer.Metric.from_unit/1","type":"function"},{"doc":"","ref":"Membrane.Buffer.Metric.html#c:split_buffers/2","title":"Membrane.Buffer.Metric.split_buffers/2","type":"callback"},{"doc":"","ref":"Membrane.Buffer.Metric.html#t:unit/0","title":"Membrane.Buffer.Metric.unit/0","type":"type"},{"doc":"Implementation of Membrane.Buffer.Metric for the :bytes unit","ref":"Membrane.Buffer.Metric.ByteSize.html","title":"Membrane.Buffer.Metric.ByteSize","type":"module"},{"doc":"Implementation of Membrane.Buffer.Metric for the :buffers unit","ref":"Membrane.Buffer.Metric.Count.html","title":"Membrane.Buffer.Metric.Count","type":"module"},{"doc":"Generic discontinuity event. This event means that flow of buffers in the stream was interrupted, but stream itself is not done. Frequent reasons for this are soundcards drops while capturing sound, network data loss etc. If duration of the discontinuity is known, it can be passed as an argument.","ref":"Membrane.Event.Discontinuity.html","title":"Membrane.Event.Discontinuity","type":"module"},{"doc":"","ref":"Membrane.Event.Discontinuity.html#t:duration/0","title":"Membrane.Event.Discontinuity.duration/0","type":"type"},{"doc":"Generic discontinuity event. This event means that flow of buffers in the stream was interrupted, but stream itself is not done. Frequent reasons for this are soundcards drops while capturing sound, network data loss etc. If duration of the discontinuity is known, it can be passed as an argument.","ref":"Membrane.Event.Discontinuity.html#t:t/0","title":"Membrane.Event.Discontinuity.t/0","type":"type"},{"doc":"Generic underrun event. This event means that certain element is willing to consume more buffers, but there are none available. It makes sense to use this event as an upstream event to notify previous elements in the pipeline that they should generate more buffers.","ref":"Membrane.Event.Underrun.html","title":"Membrane.Event.Underrun","type":"module"},{"doc":"Generic underrun event. This event means that certain element is willing to consume more buffers, but there are none available. It makes sense to use this event as an upstream event to notify previous elements in the pipeline that they should generate more buffers.","ref":"Membrane.Event.Underrun.html#t:t/0","title":"Membrane.Event.Underrun.t/0","type":"type"},{"doc":"Default implementation of Membrane.EventProtocol . If use d in defimpl , not implemented callbacks fallback to default ones.","ref":"Membrane.EventProtocol.DefaultImpl.html","title":"Membrane.EventProtocol.DefaultImpl","type":"module"},{"doc":"Behaviour that should be implemented by every module that has Membrane.Payload protocol implementation.","ref":"Membrane.Payload.Behaviour.html","title":"Membrane.Payload.Behaviour","type":"behaviour"},{"doc":"Creates an empty payload","ref":"Membrane.Payload.Behaviour.html#c:empty/0","title":"Membrane.Payload.Behaviour.empty/0","type":"callback"},{"doc":"Creates a new payload initialized with the given binary","ref":"Membrane.Payload.Behaviour.html#c:new/1","title":"Membrane.Payload.Behaviour.new/1","type":"callback"},{"doc":"Membrane.Payload.Behaviour implementation for binary payload. Complements Membrane.Payload protocol implementation.","ref":"Membrane.Payload.Binary.html","title":"Membrane.Payload.Binary","type":"module"},{"doc":"Wrapper around the Elixir logger. Adds Membrane prefixes and handles verbose logging. Prefixes By default, this wrapper prepends each log with a prefix containing the context of the log, such as element name. This can be turned off via configuration: use Mix.Config config :membrane_core , :logger , prefix : false Regardless of the config, the prefix is passed to Logger metadata under :mb_prefix key. Prefixes are passed via process dictionary, so they have process-wide scope, but it can be extended with get_prefix/0 and set_prefix/1 . Verbose logging For verbose debug logs that should be silenced by default, use debug_verbose/2 macro. Verbose logs are purged in the compile time, unless turned on via configuration: use Mix.Config config :membrane_core , :logger , verbose : true Verbose debugs should be used for logs that are USUALLY USEFUL for debugging, but printed so often that they make the output illegible. For example, it may be a good idea to debug_verbose from within c:Membrane.WithInputPads.handle_buffer/4 or Membrane.Element.WithOutputPads.handle_demand/5 callbacks.","ref":"Membrane.Logger.html","title":"Membrane.Logger","type":"module"},{"doc":"Wrapper around Logger.bare_log/3 that adds Membrane prefix. For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#bare_log/3","title":"Membrane.Logger.bare_log/3","type":"function"},{"doc":"Wrapper around Logger.debug/2 that adds Membrane prefix. For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#debug/2","title":"Membrane.Logger.debug/2","type":"macro"},{"doc":"Macro for verbose debug logs, that are silenced by default. For details, see the 'verbose logging' section of the moduledoc.","ref":"Membrane.Logger.html#debug_verbose/2","title":"Membrane.Logger.debug_verbose/2","type":"macro"},{"doc":"Wrapper around Logger.error/2 that adds Membrane prefix. For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#error/2","title":"Membrane.Logger.error/2","type":"macro"},{"doc":"Returns the Membrane logger config.","ref":"Membrane.Logger.html#get_config/0","title":"Membrane.Logger.get_config/0","type":"function"},{"doc":"Returns value at given key in the Membrane logger config.","ref":"Membrane.Logger.html#get_config/2","title":"Membrane.Logger.get_config/2","type":"function"},{"doc":"Returns the logger prefix. Returns an empty string if no prefix is set.","ref":"Membrane.Logger.html#get_prefix/0","title":"Membrane.Logger.get_prefix/0","type":"function"},{"doc":"Wrapper around Logger.info/2 that adds Membrane prefix. For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#info/2","title":"Membrane.Logger.info/2","type":"macro"},{"doc":"Wrapper around Logger.log/3 that adds Membrane prefix. For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#log/3","title":"Membrane.Logger.log/3","type":"macro"},{"doc":"Sets the logger prefix. Avoid using in Membrane-managed processes. This function is intended to enable setting prefix obtained in a Membrane-managed process via get_prefix/1 . If some custom data needs to be prepended to logs, please use Logger.metadata/1 . Prefixes in Membrane-managed processes are set automatically and using this function there would overwrite them, which is usually unintended.","ref":"Membrane.Logger.html#set_prefix/1","title":"Membrane.Logger.set_prefix/1","type":"function"},{"doc":"Wrapper around Logger.warn/2 that adds Membrane prefix. For details, see the 'prefixes' section of the moduledoc.","ref":"Membrane.Logger.html#warn/2","title":"Membrane.Logger.warn/2","type":"macro"},{"doc":"This module contains a set of assertion functions and macros. These assertions will work ONLY in conjunction with Membrane.Testing.Pipeline and ONLY when pid of tested pipeline is provided as an argument to these assertions.","ref":"Membrane.Testing.Assertions.html","title":"Membrane.Testing.Assertions","type":"module"},{"doc":"Asserts that Membrane.Testing.Pipeline child with name child removed or is going to remove it's pad with ref pad within the timeout period specified in milliseconds.","ref":"Membrane.Testing.Assertions.html#assert_child_pad_removed/4","title":"Membrane.Testing.Assertions.assert_child_pad_removed/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Pipeline received or is going to receive end_of_stream notification about from the element with a name element_name within the timeout period specified in milliseconds. assert_end_of_stream ( pipeline , :an_element )","ref":"Membrane.Testing.Assertions.html#assert_end_of_stream/4","title":"Membrane.Testing.Assertions.assert_end_of_stream/4","type":"macro"},{"doc":"Asserts that a crash group within pipeline will be down within the timeout period specified in milliseconds. Usage example: assert_pipeline_crash_group_down ( pipeline , :group_1 )","ref":"Membrane.Testing.Assertions.html#assert_pipeline_crash_group_down/3","title":"Membrane.Testing.Assertions.assert_pipeline_crash_group_down/3","type":"macro"},{"doc":"Asserts that pipeline received or will receive a notification from the element with name element_name within the timeout period specified in milliseconds. The notification_pattern must be a match pattern. assert_pipeline_notified ( pipeline , :element_name , :hi )","ref":"Membrane.Testing.Assertions.html#assert_pipeline_notified/4","title":"Membrane.Testing.Assertions.assert_pipeline_notified/4","type":"macro"},{"doc":"","ref":"Membrane.Testing.Assertions.html#assert_pipeline_play/2","title":"Membrane.Testing.Assertions.assert_pipeline_play/2","type":"macro"},{"doc":"Asserts that pipeline received or will receive a message matching message_pattern from another process within the timeout period specified in milliseconds. The message_pattern must be a match pattern. assert_pipeline_receive ( pid , :tick ) Such call would flunk if the message :tick has not been handled by c:Membrane.Parent.handle_info/3 within the timeout .","ref":"Membrane.Testing.Assertions.html#assert_pipeline_receive/3","title":"Membrane.Testing.Assertions.assert_pipeline_receive/3","type":"macro"},{"doc":"","ref":"Membrane.Testing.Assertions.html#assert_pipeline_setup/2","title":"Membrane.Testing.Assertions.assert_pipeline_setup/2","type":"macro"},{"doc":"Asserts that Membrane.Testing.MockResourceGuard was requested to cleanup a given tag.","ref":"Membrane.Testing.Assertions.html#assert_resource_guard_cleanup/3","title":"Membrane.Testing.Assertions.assert_resource_guard_cleanup/3","type":"macro"},{"doc":"Asserts that a cleanup function was registered in Membrane.Testing.MockResourceGuard .","ref":"Membrane.Testing.Assertions.html#assert_resource_guard_register/4","title":"Membrane.Testing.Assertions.assert_resource_guard_register/4","type":"macro"},{"doc":"Asserts that a tag was unregistered in Membrane.Testing.MockResourceGuard .","ref":"Membrane.Testing.Assertions.html#assert_resource_guard_unregister/3","title":"Membrane.Testing.Assertions.assert_resource_guard_unregister/3","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink with name sink_name received or will receive a buffer matching pattern within the timeout period specified in milliseconds. When the Membrane.Testing.Sink is a part of Membrane.Testing.Pipeline you can assert whether it received a buffer matching provided pattern. import Membrane.ChildrenSpec spec = [ ... |&gt; child ( :the_sink , % Membrane.Testing.Sink { } ) |&gt; ... ] { :ok , pid } = Membrane.Testing.Pipeline . start_link ( spec : spec , ) You can match for exact value: assert_sink_buffer ( pid , :the_sink , % Membrane.Buffer { payload : ^ specific_payload } ) You can also use pattern to extract data from the buffer: assert_sink_buffer ( pid , :sink , % Buffer { payload : &lt;&lt; data :: 16 &gt;&gt; &lt;&gt; &lt;&lt; 255 &gt;&gt; } ) do_something ( data )","ref":"Membrane.Testing.Assertions.html#assert_sink_buffer/4","title":"Membrane.Testing.Assertions.assert_sink_buffer/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink with name sink_name received or will receive an event within the timeout period specified in milliseconds. When a Membrane.Testing.Sink is part of Membrane.Testing.Pipeline you can assert whether it received an event matching a provided pattern. assert_sink_event ( pid , :the_sink , % Discontinuity { } )","ref":"Membrane.Testing.Assertions.html#assert_sink_event/4","title":"Membrane.Testing.Assertions.assert_sink_event/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink with name sink_name received or will receive stream format matching pattern within the timeout period specified in milliseconds. When the Membrane.Testing.Sink is a part of Membrane.Testing.Pipeline you can assert whether it received stream format matching provided pattern. import Membrane.ChildrenSpec children = [ ... , child ( :the_sink , % Membrane.Testing.Sink { } ) ] { :ok , pid } = Membrane.Testing.Pipeline . start_link ( spec : children , ) You can match for exact value: assert_sink_stream_format ( pid , :the_sink , % StreamFormat { prop : ^ value } ) You can also use pattern to extract data from the stream_format: assert_sink_stream_format ( pid , :the_sink , % StreamFormat { prop : value } ) do_something ( value )","ref":"Membrane.Testing.Assertions.html#assert_sink_stream_format/4","title":"Membrane.Testing.Assertions.assert_sink_stream_format/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Pipeline received or is going to receive start_of_stream notification from the element with a name element_name within the timeout period specified in milliseconds. assert_start_of_stream ( pipeline , :an_element )","ref":"Membrane.Testing.Assertions.html#assert_start_of_stream/4","title":"Membrane.Testing.Assertions.assert_start_of_stream/4","type":"macro"},{"doc":"Refutes that a crash group within pipeline won't be down within the timeout period specified in milliseconds. Usage example: refute_pipeline_crash_group_down ( pipeline , :group_1 )","ref":"Membrane.Testing.Assertions.html#refute_pipeline_crash_group_down/3","title":"Membrane.Testing.Assertions.refute_pipeline_crash_group_down/3","type":"macro"},{"doc":"Refutes that pipeline received or will receive a notification from the element with name element_name within the timeout period specified in milliseconds. The notification_pattern must be a match pattern. refute_pipeline_notified ( pipeline , :element_name , :hi )","ref":"Membrane.Testing.Assertions.html#refute_pipeline_notified/4","title":"Membrane.Testing.Assertions.refute_pipeline_notified/4","type":"macro"},{"doc":"Asserts that pipeline has not received and will not receive a message from another process matching message_pattern within the timeout period specified in milliseconds. The message_pattern must be a match pattern. refute_pipeline_receive ( pid , :tick ) Such call would flunk if the message :tick has been handled by c:Membrane.Parent.handle_info/3 .","ref":"Membrane.Testing.Assertions.html#refute_pipeline_receive/3","title":"Membrane.Testing.Assertions.refute_pipeline_receive/3","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink with name sink_name has not received and will not receive a buffer matching buffer_pattern within the timeout period specified in milliseconds. Similarly as in the assert_sink_buffer/4 the_sink needs to be part of a Membrane.Testing.Pipeline . refute_sink_buffer ( pipeline , :the_sink , % Buffer { payload : &lt;&lt; 0xA1 , 0xB2 &gt;&gt; } ) Such expression will flunk if the_sink received or will receive a buffer with payload &lt;&lt;0xA1, 0xB2&gt;&gt; .","ref":"Membrane.Testing.Assertions.html#refute_sink_buffer/4","title":"Membrane.Testing.Assertions.refute_sink_buffer/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink has not received and will not receive event matching provided pattern within the timeout period specified in milliseconds. refute_sink_event ( pid , :the_sink , % Discontinuity { } )","ref":"Membrane.Testing.Assertions.html#refute_sink_event/4","title":"Membrane.Testing.Assertions.refute_sink_event/4","type":"macro"},{"doc":"Asserts that Membrane.Testing.Sink with name sink_name has not received and will not receive stream format matching stream_format_pattern within the timeout period specified in milliseconds. Similarly as in the assert_sink_stream_format/4 the_sink needs to be part of a Membrane.Testing.Pipeline . refute_sink_stream_format ( pipeline , :the_sink , % StreamFormat { prop : ^ val } ) Such expression will flunk if the_sink received or will receive stream_format with property equal to value of val variable.","ref":"Membrane.Testing.Assertions.html#refute_sink_stream_format/4","title":"Membrane.Testing.Assertions.refute_sink_stream_format/4","type":"macro"},{"doc":"Testing Element for supplying data based on generator function or payloads passed through options. It is very similar to Membrane.Testing.Source but is has dynamic pad instead of static. Example usage As mentioned earlier you can use this element in one of two ways, providing either a generator function or an Enumerable.t . If you provide an Enumerable.t with payloads, then each of those payloads will be wrapped in a Membrane.Buffer and sent through :output pad. % Source { output : [ 0xA1 , 0xB2 , 0xC3 , 0xD4 ] } In order to specify Membrane.Testing.Source with generator function you need to provide initial state and function that matches generator/0 type. This function should take state and demand size as its arguments and return a tuple consisting of actions that element will return during the Membrane.Element.WithOutputPads.handle_demand/5 callback and new state. generator_function = fn state , pad , size -&gt; #generate some buffers { actions , state + 1 } end % Source { output : { 1 , generator_function } } Element options Passed via struct Membrane.Testing.DynamicSource.t/0 output { initial_state :: any ( ) , generator ( ) } | Enum . t ( ) Default value: {0, &amp;Membrane.Testing.DynamicSource.default_buf_gen/3} If output is an enumerable with Membrane.Payload.t/0 then buffer containing those payloads will be sent through the :output pad and followed by Membrane.Element.Action.end_of_stream/0 . If output is a {initial_state, function} tuple then the the function will be invoked each time handle_demand is called. It is an action generator that takes two arguments. The first argument is the state that is initially set to initial_state . The second one defines the pad on which the demand has been requested. The third one defines the size of the demand. Such function should return {actions, next_state} where actions is a list of actions that will be returned from handle_demand/4 and next_state is the value that will be used for the next call. stream_format struct ( ) Default value: %Membrane.RemoteStream{content_format: nil, type: :bytestream} Stream format to be sent before the output . Pads :output Accepted formats: _any Direction: :output Availability: :on_request Flow control: :manual Demand unit: nil","ref":"Membrane.Testing.DynamicSource.html","title":"Membrane.Testing.DynamicSource","type":"module"},{"doc":"","ref":"Membrane.Testing.DynamicSource.html#default_buf_gen/3","title":"Membrane.Testing.DynamicSource.default_buf_gen/3","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.Testing.DynamicSource.html#options/0","title":"Membrane.Testing.DynamicSource.options/0","type":"function"},{"doc":"","ref":"Membrane.Testing.DynamicSource.html#t:generator/0","title":"Membrane.Testing.DynamicSource.generator/0","type":"type"},{"doc":"Struct containing options for Membrane.Testing.DynamicSource","ref":"Membrane.Testing.DynamicSource.html#t:t/0","title":"Membrane.Testing.DynamicSource.t/0","type":"type"},{"doc":"Membrane element. Element options Passed via struct Membrane.Testing.Endpoint.t/0 autodemand boolean ( ) Default value: true If true element will automatically make demands. If it is set to false demand has to be triggered manually by sending :make_demand message. output { initial_state :: any ( ) , generator } | Enum . t ( ) Default value: {0, &amp;Membrane.Testing.Endpoint.default_buf_gen/2} If output is an enumerable with Membrane.Payload.t/0 then buffer containing those payloads will be sent through the :output pad and followed by Membrane.Element.Action.end_of_stream/0 . If output is a {initial_state, function} tuple then the the function will be invoked each time handle_demand is called. It is an action generator that takes two arguments. The first argument is the state that is initially set to initial_state . The second one defines the size of the demand. Such function should return {actions, next_state} where actions is a list of actions that will be returned from handle_demand/4 and next_state is the value that will be used for the next call. stream_format struct ( ) Default value: %Membrane.RemoteStream{content_format: nil, type: :bytestream} Stream format to be sent before the output . Pads :input Accepted formats: _any Direction: :input Availability: :always Flow control: :manual Demand unit: :buffers :output Accepted formats: _any Direction: :output Availability: :always Flow control: :manual Demand unit: nil","ref":"Membrane.Testing.Endpoint.html","title":"Membrane.Testing.Endpoint","type":"module"},{"doc":"","ref":"Membrane.Testing.Endpoint.html#default_buf_gen/2","title":"Membrane.Testing.Endpoint.default_buf_gen/2","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.Testing.Endpoint.html#options/0","title":"Membrane.Testing.Endpoint.options/0","type":"function"},{"doc":"Creates output with generator function from list of buffers.","ref":"Membrane.Testing.Endpoint.html#output_from_buffers/1","title":"Membrane.Testing.Endpoint.output_from_buffers/1","type":"function"},{"doc":"","ref":"Membrane.Testing.Endpoint.html#t:generator/0","title":"Membrane.Testing.Endpoint.generator/0","type":"type"},{"doc":"Struct containing options for Membrane.Testing.Endpoint","ref":"Membrane.Testing.Endpoint.html#t:t/0","title":"Membrane.Testing.Endpoint.t/0","type":"type"},{"doc":"Empty event that can be used in tests","ref":"Membrane.Testing.Event.html","title":"Membrane.Testing.Event","type":"module"},{"doc":"Mock for Membrane.ResourceGuard . Informs the test process about registered cleanup functions and tags. Works with Membrane.Testing.Assertions , for example Membrane.Testing.Assertions.assert_resource_guard_register/4 : iex&gt; guard = Membrane.Testing.MockResourceGuard . start_link_supervised! ( ) ...&gt; Membrane.ResourceGuard . register ( guard , fn -&gt; :abc end , tag : :some_tag ) ...&gt; import Membrane.Testing.Assertions ...&gt; assert_resource_guard_register ( guard , function , :some_tag ) ...&gt; function . ( ) :abc","ref":"Membrane.Testing.MockResourceGuard.html","title":"Membrane.Testing.MockResourceGuard","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Membrane.Testing.MockResourceGuard.html#child_spec/1","title":"Membrane.Testing.MockResourceGuard.child_spec/1","type":"function"},{"doc":"","ref":"Membrane.Testing.MockResourceGuard.html#start_link/1","title":"Membrane.Testing.MockResourceGuard.start_link/1","type":"function"},{"doc":"","ref":"Membrane.Testing.MockResourceGuard.html#start_link_supervised!/1","title":"Membrane.Testing.MockResourceGuard.start_link_supervised!/1","type":"function"},{"doc":"","ref":"Membrane.Testing.MockResourceGuard.html#t:options/0","title":"Membrane.Testing.MockResourceGuard.options/0","type":"type"},{"doc":"This Pipeline was created to reduce testing boilerplate and ease communication with its children. It also provides a utility for informing testing process about playback changes and received notifications. When you want a build Pipeline to test your children you need three things: Pipeline Module List of children Links between those children To start a testing pipeline you need to build a keyword list representing the options used to determine the pipeline's behaviour and then pass that options list to the Membrane.Testing.Pipeline.start_link_supervised!/1 . The testing pipeline can be started in one of two modes - either with its :default behaviour, or by injecting a custom module behaviour. The usage of a :default pipeline implementation is presented below: links = [ child ( :el1 , MembraneElement1 ) |&gt; child ( :el2 , MembraneElement2 ) ... ] options = [ module : :default # :default is the default value for this parameter, so you do not need to pass it here spec : links ] pipeline = Membrane.Testing.Pipeline . start_link_supervised! ( options ) You can also pass your custom pipeline's module as a :module option of the options list. Every callback of the module will be executed before the callbacks of Testing.Pipeline. Passed module has to return a proper spec. There should be no children nor links specified in options passed to test pipeline as that would result in a failure. options = [ module : Your.Module ] pipeline = Membrane.Testing.Pipeline . start_link_supervised! ( options ) See Membrane.Testing.Pipeline.options/0 for available options. Assertions This pipeline is designed to work with Membrane.Testing.Assertions . Check them out or see example below for more details. Messaging children You can send messages to children using their names specified in the children list. Please check message_child/3 for more details. Example usage Firstly, we can start the pipeline providing its options as a keyword list: import Membrane.ChildrenSpec children = [ child ( source , % Membrane.Testing.Source { } ) |&gt; child ( :tested_element , TestedElement ) |&gt; child ( sink , % Membrane.Testing.Sink { } ) ] {:ok, pipeline} = Membrane.Testing.Pipeline.start_link(spec: links) We can now wait till the end of the stream reaches the sink element (don't forget to import Membrane.Testing.Assertions ): assert_end_of_stream ( pipeline , :sink ) We can also assert that the Membrane.Testing.Sink processed a specific buffer: assert_sink_buffer ( pipeline , :sink , % Membrane.Buffer { payload : 1 } )","ref":"Membrane.Testing.Pipeline.html","title":"Membrane.Testing.Pipeline","type":"module"},{"doc":"Returns child specification for spawning under a supervisor","ref":"Membrane.Testing.Pipeline.html#child_spec/1","title":"Membrane.Testing.Pipeline.child_spec/1","type":"function"},{"doc":"Executes specified actions in the pipeline. The actions are returned from the handle_info callback.","ref":"Membrane.Testing.Pipeline.html#execute_actions/2","title":"Membrane.Testing.Pipeline.execute_actions/2","type":"function"},{"doc":"Returns the pid of the children process. Accepts pipeline pid as a first argument and a child reference or a list of child references representing a path as a second argument. If second argument is a child reference, function gets pid of this child from pipeline. If second argument is a path of child references, function gets pid of last a component pointed by this path. Returns {:ok, child_pid} , if a child was succesfully found {:error, reason} , if, for example, pipeline is not alive or children path is invalid","ref":"Membrane.Testing.Pipeline.html#get_child_pid/2","title":"Membrane.Testing.Pipeline.get_child_pid/2","type":"function"},{"doc":"Returns the pid of the children process. Works as get_child_pid/2, but raises an error instead of returning {:error, reason} tuple.","ref":"Membrane.Testing.Pipeline.html#get_child_pid!/2","title":"Membrane.Testing.Pipeline.get_child_pid!/2","type":"function"},{"doc":"Sends message to a child by Element name. Example Knowing that pipeline has child named sink , message can be sent as follows: message_child ( pipeline , :sink , { :message , &quot;to handle&quot; } )","ref":"Membrane.Testing.Pipeline.html#message_child/3","title":"Membrane.Testing.Pipeline.message_child/3","type":"function"},{"doc":"","ref":"Membrane.Testing.Pipeline.html#start/1","title":"Membrane.Testing.Pipeline.start/1","type":"function"},{"doc":"","ref":"Membrane.Testing.Pipeline.html#start_link/1","title":"Membrane.Testing.Pipeline.start_link/1","type":"function"},{"doc":"Starts the pipeline under the ExUnit test supervisor and links it to the current process. Can be used only in tests.","ref":"Membrane.Testing.Pipeline.html#start_link_supervised/1","title":"Membrane.Testing.Pipeline.start_link_supervised/1","type":"function"},{"doc":"","ref":"Membrane.Testing.Pipeline.html#start_link_supervised!/1","title":"Membrane.Testing.Pipeline.start_link_supervised!/1","type":"function"},{"doc":"Starts the pipeline under the ExUnit test supervisor. Can be used only in tests.","ref":"Membrane.Testing.Pipeline.html#start_supervised/1","title":"Membrane.Testing.Pipeline.start_supervised/1","type":"function"},{"doc":"","ref":"Membrane.Testing.Pipeline.html#start_supervised!/1","title":"Membrane.Testing.Pipeline.start_supervised!/1","type":"function"},{"doc":"Changes pipeline's playback to :stopped and terminates its process.","ref":"Membrane.Testing.Pipeline.html#terminate/2","title":"Membrane.Testing.Pipeline.terminate/2","type":"function"},{"doc":"","ref":"Membrane.Testing.Pipeline.html#t:options/0","title":"Membrane.Testing.Pipeline.options/0","type":"type"},{"doc":"Sink Element that notifies the pipeline about buffers and events it receives. By default Sink will demand buffers automatically, but you can override that behaviour by using autodemand option. If set to false no automatic demands shall be made. Demands can be then triggered by sending {:make_demand, size} message. This element can be used in conjunction with Membrane.Testing.Pipeline to enable asserting on buffers and events it receives. alias Membrane.Testing links = [ ... |&gt; child ( :sink , % Testing.Sink { } ) |&gt; ... ] { :ok , pid } = Testing.Pipeline . start_link ( spec : links ) Asserting that Membrane.Testing.Sink element processed a buffer that matches a specific pattern can be achieved using Membrane.Testing.Assertions.assert_sink_buffer/3 . assert_sink_buffer ( pid , :sink , % Membrane.Buffer { payload : 255 } ) Element options Passed via struct Membrane.Testing.Sink.t/0 autodemand boolean ( ) Default value: true If true element will automatically make demands. If it is set to false demand has to be triggered manually by sending :make_demand message. Pads :input Accepted formats: _any Direction: :input Availability: :always Flow control: :manual Demand unit: :buffers","ref":"Membrane.Testing.Sink.html","title":"Membrane.Testing.Sink","type":"module"},{"doc":"Returns description of options available for this module","ref":"Membrane.Testing.Sink.html#options/0","title":"Membrane.Testing.Sink.options/0","type":"function"},{"doc":"Struct containing options for Membrane.Testing.Sink","ref":"Membrane.Testing.Sink.html#t:t/0","title":"Membrane.Testing.Sink.t/0","type":"type"},{"doc":"Testing Element for supplying data based on generator function or payloads passed through options. Example usage As mentioned earlier you can use this element in one of two ways, providing either a generator function or an Enumerable.t . If you provide an Enumerable.t with payloads, then each of those payloads will be wrapped in a Membrane.Buffer and sent through :output pad. % Source { output : [ 0xA1 , 0xB2 , 0xC3 , 0xD4 ] } In order to specify Membrane.Testing.Source with generator function you need to provide initial state and function that matches generator/0 type. This function should take state and demand size as its arguments and return a tuple consisting of actions that element will return during the Membrane.Element.WithOutputPads.handle_demand/5 callback and new state. generator_function = fn state , size -&gt; #generate some buffers { actions , state + 1 } end % Source { output : { 1 , generator_function } } Element options Passed via struct Membrane.Testing.Source.t/0 output Enum . t ( ) | { initial_state :: any ( ) , generator } Default value: {0, &amp;Membrane.Testing.Source.default_buf_gen/2} If output is an Enumerable, then each element of it will be sent through the :output pad, followed by Membrane.Element.Action.end_of_stream/0 . Each element of the Enumerable must be either Membrane.Buffer.t/0 or Membrane.Payload.t/0 . In the latter case, it will be automatically wrapped into Membrane.Buffer.t/0 before sending. Otherwise, if output is a {initial_state, function} tuple then the the function will be invoked each time handle_demand is called. It is an action generator that takes two arguments. The first argument is the state that is initially set to initial_state . The second one defines the size of the demand. Such function should return {actions, next_state} where actions is a list of actions that will be returned from handle_demand/4 and next_state is the value that will be used for the next call. stream_format struct ( ) Default value: %Membrane.RemoteStream{content_format: nil, type: :bytestream} StreamFormat to be sent before the output . Pads :output Accepted formats: _any Direction: :output Availability: :always Flow control: :manual Demand unit: nil","ref":"Membrane.Testing.Source.html","title":"Membrane.Testing.Source","type":"module"},{"doc":"","ref":"Membrane.Testing.Source.html#default_buf_gen/2","title":"Membrane.Testing.Source.default_buf_gen/2","type":"function"},{"doc":"Returns description of options available for this module","ref":"Membrane.Testing.Source.html#options/0","title":"Membrane.Testing.Source.options/0","type":"function"},{"doc":"Creates output with generator function from list of buffers.","ref":"Membrane.Testing.Source.html#output_from_buffers/1","title":"Membrane.Testing.Source.output_from_buffers/1","type":"function"},{"doc":"","ref":"Membrane.Testing.Source.html#t:generator/0","title":"Membrane.Testing.Source.generator/0","type":"type"},{"doc":"Struct containing options for Membrane.Testing.Source","ref":"Membrane.Testing.Source.html#t:t/0","title":"Membrane.Testing.Source.t/0","type":"type"},{"doc":"Clock is a Membrane utility that allows elements to measure time according to a particular clock, which can be e.g. a soundcard hardware clock. Internally, Clock is a GenServer process that can receive updates (see update_message/0 ), which are messages containing amount of time until the next update. For example, a sink playing audio to the sound card can send an update before each write to the sound card buffer (for practical reasons that can be done every 100 or 1000 writes). Although it might be more intuitive to send updates with the time passed, in practice the described approach turns out to be more convenient, as it simplifies the first update. Basing on updates, Clock calculates the ratio/0 of its time to the reference time. The reference time can be configured with :time_provider option. The ratio is broadcasted (see ratio_message/0 ) to subscribers (see subscribe/2 ) processes willing to synchronize to the custom clock. Subscribers can adjust their timers according to received ratio - timers started with Membrane.Element.Action.start_timer/0 action in elements do it automatically. Initial ratio is equal to 1, which means that if no updates are received, Clock is synchronized to the reference time. Proxy mode Clock can work in proxy mode, which means it cannot receive updates, but it receives ratio from another clock instead, and forwards it to subscribers. Proxy mode is enabled with proxy_for: pid or proxy: true (no initial proxy) option, and the proxy is set/changed using proxy_for/2 .","ref":"Membrane.Clock.html","title":"Membrane.Clock","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Membrane.Clock.html#child_spec/1","title":"Membrane.Clock.child_spec/1","type":"function"},{"doc":"Sets a new proxy clock to clock_to_proxy_for .","ref":"Membrane.Clock.html#proxy_for/2","title":"Membrane.Clock.proxy_for/2","type":"function"},{"doc":"","ref":"Membrane.Clock.html#start/2","title":"Membrane.Clock.start/2","type":"function"},{"doc":"","ref":"Membrane.Clock.html#start_link/2","title":"Membrane.Clock.start_link/2","type":"function"},{"doc":"Subscribes pid for receiving ratio_message/0 messages from the clock. This function can be called multiple times from the same process. To unsubscribe, unsubscribe/2 should be called the same amount of times. The subscribed pid always receives one message, regardless of how many times it called subscribe/2 .","ref":"Membrane.Clock.html#subscribe/2","title":"Membrane.Clock.subscribe/2","type":"function"},{"doc":"Unsubscribes pid from receiving ratio_message/0 messages from the clock. For unsubscription to take effect, unsubscribe/2 should be called the same amount of times as subscribe/2 .","ref":"Membrane.Clock.html#unsubscribe/2","title":"Membrane.Clock.unsubscribe/2","type":"function"},{"doc":"Options accepted by start_link/2 and start/2 functions. They are the following: time_provider - function providing the reference time in milliseconds proxy - determines whether the Clock should work in proxy mode proxy_for - enables the proxy mode and sets proxied Clock to pid Check the moduledoc for more details.","ref":"Membrane.Clock.html#t:option/0","title":"Membrane.Clock.option/0","type":"type"},{"doc":"Ratio of the Clock time to the reference time.","ref":"Membrane.Clock.html#t:ratio/0","title":"Membrane.Clock.ratio/0","type":"type"},{"doc":"Ratio message sent by the Clock to all its subscribers. It contains the ratio of the custom clock time to the reference time.","ref":"Membrane.Clock.html#t:ratio_message/0","title":"Membrane.Clock.ratio_message/0","type":"type"},{"doc":"Clock is a Membrane utility that allows elements to measure time according to a particular clock, which can be e.g. a soundcard hardware clock. Internally, Clock is a GenServer process that can receive updates (see update_message/0 ), which are messages containing amount of time until the next update. For example, a sink playing audio to the sound card can send an update before each write to the sound card buffer (for practical reasons that can be done every 100 or 1000 writes). Although it might be more intuitive to send updates with the time passed, in practice the described approach turns out to be more convenient, as it simplifies the first update. Basing on updates, Clock calculates the ratio/0 of its time to the reference time. The reference time can be configured with :time_provider option. The ratio is broadcasted (see ratio_message/0 ) to subscribers (see subscribe/2 ) processes willing to synchronize to the custom clock. Subscribers can adjust their timers according to received ratio - timers started with Membrane.Element.Action.start_timer/0 action in elements do it automatically. Initial ratio is equal to 1, which means that if no updates are received, Clock is synchronized to the reference time. Proxy mode Clock can work in proxy mode, which means it cannot receive updates, but it receives ratio from another clock instead, and forwards it to subscribers. Proxy mode is enabled with proxy_for: pid or proxy: true (no initial proxy) option, and the proxy is set/changed using proxy_for/2 .","ref":"Membrane.Clock.html#t:t/0","title":"Membrane.Clock.t/0","type":"type"},{"doc":"Update message received by the Clock. It should contain the time till the next update.","ref":"Membrane.Clock.html#t:update_message/0","title":"Membrane.Clock.update_message/0","type":"type"},{"doc":"A list consisting of following pipeline/bin/element names down the assembled pipeline. It traces element's path inside a pipeline. Information is being stored in a process dictionary and can be set/appended to.","ref":"Membrane.ComponentPath.html","title":"Membrane.ComponentPath","type":"module"},{"doc":"Returns formatted string of given path's names.","ref":"Membrane.ComponentPath.html#format/1","title":"Membrane.ComponentPath.format/1","type":"function"},{"doc":"Returns currently stored path. If path has not been set, empty list is returned.","ref":"Membrane.ComponentPath.html#get/0","title":"Membrane.ComponentPath.get/0","type":"function"},{"doc":"Works the same way as format/1 but uses currently stored path.","ref":"Membrane.ComponentPath.html#get_formatted/0","title":"Membrane.ComponentPath.get_formatted/0","type":"function"},{"doc":"Sets current path. If path had already existed then replaces it.","ref":"Membrane.ComponentPath.html#set/1","title":"Membrane.ComponentPath.set/1","type":"function"},{"doc":"A list consisting of following pipeline/bin/element names down the assembled pipeline. It traces element's path inside a pipeline. Information is being stored in a process dictionary and can be set/appended to.","ref":"Membrane.ComponentPath.html#t:path/0","title":"Membrane.ComponentPath.path/0","type":"type"},{"doc":"Playback defines whether media is processed within a pipeline ( :playing ) or not ( :stopped ). Component playback will not enter :playing state until its parent playback is playing and all components from the spec , that started this component have ended their setups and linked their pads. By default, component setup ends with the end of handle_setup/2 callback. If {:setup, :incomplete} is returned there, setup lasts until {:setup, :complete} is returned from antoher callback. Untils the setup lasts, the component won't enter :playing playback.","ref":"Membrane.Playback.html","title":"Membrane.Playback","type":"module"},{"doc":"Playback defines whether media is processed within a pipeline ( :playing ) or not ( :stopped ). Component playback will not enter :playing state until its parent playback is playing and all components from the spec , that started this component have ended their setups and linked their pads. By default, component setup ends with the end of handle_setup/2 callback. If {:setup, :incomplete} is returned there, setup lasts until {:setup, :complete} is returned from antoher callback. Untils the setup lasts, the component won't enter :playing playback.","ref":"Membrane.Playback.html#t:t/0","title":"Membrane.Playback.t/0","type":"type"},{"doc":"Utility for handling resources that must be cleaned up after use. This utility uses a separate process that allows registering functions that are called when the owner process (passed to start_link/1 ) dies for any reason. Each Membrane component spawns its resource guard on startup and provides it via callback context. Example def handle_setup ( ctx , state ) do resource = MyResource . create ( ) Membrane.ResourceGuard . register ( ctx . resource_guard , fn -&gt; MyResource . cleanup ( resource ) end ) { :ok , %{ state | my_resource : resource } } end","ref":"Membrane.ResourceGuard.html","title":"Membrane.ResourceGuard","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Membrane.ResourceGuard.html#child_spec/1","title":"Membrane.ResourceGuard.child_spec/1","type":"function"},{"doc":"Executes all cleanup functions registered in the resource gurard.","ref":"Membrane.ResourceGuard.html#cleanup/1","title":"Membrane.ResourceGuard.cleanup/1","type":"function"},{"doc":"Executes cleanup functions registered with the specifc tag. If many cleanup functions are registered with the same tag, all of them are executed.","ref":"Membrane.ResourceGuard.html#cleanup/2","title":"Membrane.ResourceGuard.cleanup/2","type":"function"},{"doc":"Registers a resource cleanup function in the resource guard. Registered functions are called in the order reverse to the registration order. Function returns a tag of the registered cleanup function. Tag can be passed under a :tag key in opts . Many functions can be registered with the same tag. If there is no :tag key in opts , tag will be result of make_ref() .","ref":"Membrane.ResourceGuard.html#register/3","title":"Membrane.ResourceGuard.register/3","type":"function"},{"doc":"","ref":"Membrane.ResourceGuard.html#start_link/1","title":"Membrane.ResourceGuard.start_link/1","type":"function"},{"doc":"Unregisters a resource cleanup function from the resource guard. All cleanup functions with tag tag are deleted.","ref":"Membrane.ResourceGuard.html#unregister/2","title":"Membrane.ResourceGuard.unregister/2","type":"function"},{"doc":"Utility for handling resources that must be cleaned up after use","ref":"Membrane.ResourceGuard.html#t:t/0","title":"Membrane.ResourceGuard.t/0","type":"type"},{"doc":"Sync allows to synchronize multiple processes, so that they could perform their jobs at the same time. The main purpose for Sync is to synchronize multiple streams within a pipeline. The flow of usage goes as follows: A Sync process is started. Processes register themselves (or are registered) in the Sync, using register/2 . Registered processes are not being synchronized till the Sync becomes active (see the next step). Each registered process is monitored and automatically unregistered upon exit. Sync can be setup to exit when all the registered processes exit by passing the empty_exit? option to start_link/2 . When all processes that need to be registered are registered, the Sync can be activated with activate/1 function. This disables registration and enables synchronization. Once a process needs to sync, it invokes sync/2 , which results in blocking until all the registered processes invoke sync/2 . This works only when the Sync is active - otherwise calling sync/2 returns immediately. Once all the ready processes invoke sync/2 , the calls return, and they become registered again. When synchronization needs to be turned off, the Sync should be deactivated with deactivate/2 . This disables synchronization and enables registration again. All the calls to sync/2 return immediately. If a process designed to work with Sync should not be synced, no_sync/0 should be used. Then all calls to sync/2 return immediately.","ref":"Membrane.Sync.html","title":"Membrane.Sync","type":"module"},{"doc":"","ref":"Membrane.Sync.html#activate/1","title":"Membrane.Sync.activate/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Membrane.Sync.html#child_spec/1","title":"Membrane.Sync.child_spec/1","type":"function"},{"doc":"","ref":"Membrane.Sync.html#deactivate/1","title":"Membrane.Sync.deactivate/1","type":"function"},{"doc":"Returns a Sync that always returns immediately when calling sync/2 on it.","ref":"Membrane.Sync.html#no_sync/0","title":"Membrane.Sync.no_sync/0","type":"function"},{"doc":"","ref":"Membrane.Sync.html#register/2","title":"Membrane.Sync.register/2","type":"function"},{"doc":"Starts a Sync process linked to the current process. Options :empty_exit? - if true, Sync automatically exits when all the registered processes exit; defaults to false","ref":"Membrane.Sync.html#start_link/2","title":"Membrane.Sync.start_link/2","type":"function"},{"doc":"","ref":"Membrane.Sync.html#sync/2","title":"Membrane.Sync.sync/2","type":"function"},{"doc":"","ref":"Membrane.Sync.html#t:status/0","title":"Membrane.Sync.status/0","type":"type"},{"doc":"A type describing the the synchronization mechanism, used to synchronize multiple processes, so that they could perform their jobs at the same time.","ref":"Membrane.Sync.html#t:t/0","title":"Membrane.Sync.t/0","type":"type"},{"doc":"Defines basic telemetry event types used by Membrane's Core. Membrane uses Telemetry Package for instrumentation and does not store or save any measurements by itself. It is user's responsibility to use some sort of metrics reporter that will be attached to :telemetry package to consume and process generated measurements. Instrumentation The following events are published by Membrane's Core with following measurement types and metadata: [:membrane, :metric, :value] - used to report metrics, such as input buffer's size inside functions, incoming events and received stream format Measurement: metric_event_value/0 Metadata: %{} [:membrane, :link, :new] - to report new link connection being initialized in pipeline. Measurement: link_event_value/0 Metadata: %{} [:membrane, :pipeline | :bin | :element, :init] - to report pipeline/element/bin initialization Measurement: init_or_terminate_event_value/0 Metadata: %{log_metadata: keyword()} , includes Logger's metadata of created component [:membrane, :pipeline | :bin | :element, :terminate] - to report pipeline/element/bin termination Measurement: init_or_terminate_event_value/0 Metadata: %{} Enabling certain metrics/events A lot of events can happen literally hundreds times per second such as registering that a buffer has been sent/processed. This behaviour can come with a great performance penalties but may be helpful for certain discoveries. To avoid any runtime overhead when the reporting is not necessary all metrics/events are hidden behind a compile-time feature flags. To enable a particular measurement one must recompile membrane core with the following snippet put inside user's application config.exs file: config :membrane_core , telemetry_flags : [ :flag_name , ... , { :metrics , [ list of metrics ] } ... ] Available flags are (those are of a very low overhead): :links - enables new links notifications :inits_and_terminates - enables notifications of init and terminate events for elements/bins/pipelines Additionally one can control which metric values should get measured by passing an option of format : {:metrics, [list of metrics]} Available metrics are: :buffer - number of buffers being sent from a particular element :bitrate - total number of bits carried by the buffers mentioned above :queue_len - number of messages in element's message queue during GenServer's handle_info invocation :stream_format - indicates that given element has received new stream format, value always equals '1' :event - indicates that given element has received a new event, value always equals '1' :store - reports the current size of a input buffer when storing a new buffer :take_and_demand - reports the current size of a input buffer when taking buffers and making a new demand","ref":"Membrane.Telemetry.html","title":"Membrane.Telemetry","type":"module"},{"doc":"","ref":"Membrane.Telemetry.html#t:event_name/0","title":"Membrane.Telemetry.event_name/0","type":"type"},{"doc":"path - element's path","ref":"Membrane.Telemetry.html#t:init_or_terminate_event_value/0","title":"Membrane.Telemetry.init_or_terminate_event_value/0","type":"type"},{"doc":"parent_path - process path of link's parent from - from element name to - to element name pad_from - from's pad name pad_to - to's pad name","ref":"Membrane.Telemetry.html#t:link_event_value/0","title":"Membrane.Telemetry.link_event_value/0","type":"type"},{"doc":"component_path - element's or bin's path metric - metric's name value - metric's value","ref":"Membrane.Telemetry.html#t:metric_event_value/0","title":"Membrane.Telemetry.metric_event_value/0","type":"type"},{"doc":"Module containing functions needed to perform handling of time. Membrane always internally uses nanosecond as a time unit. This is how all time units should represented in the code unless there's a good reason to act differently. Please note that Erlang VM may internally use different units and that may differ from platform to platform. Still, unless you need to perform calculations that do not touch hardware clock, you should use Membrane units for consistency.","ref":"Membrane.Time.html","title":"Membrane.Time","type":"module"},{"doc":"Returns time in days. If the mode argument is set to :exact (default), the result is represented as a rational number. Otherwise, if the mode is :round , the result is rounded to the nearest integer.","ref":"Membrane.Time.html#as_days/2","title":"Membrane.Time.as_days/2","type":"function"},{"doc":"Returns time in hours. If the mode argument is set to :exact (default), the result is represented as a rational number. Otherwise, if the mode is :round , the result is rounded to the nearest integer.","ref":"Membrane.Time.html#as_hours/2","title":"Membrane.Time.as_hours/2","type":"function"},{"doc":"Returns time in microseconds. If the mode argument is set to :exact (default), the result is represented as a rational number. Otherwise, if the mode is :round , the result is rounded to the nearest integer.","ref":"Membrane.Time.html#as_microseconds/2","title":"Membrane.Time.as_microseconds/2","type":"function"},{"doc":"Returns time in milliseconds. If the mode argument is set to :exact (default), the result is represented as a rational number. Otherwise, if the mode is :round , the result is rounded to the nearest integer.","ref":"Membrane.Time.html#as_milliseconds/2","title":"Membrane.Time.as_milliseconds/2","type":"function"},{"doc":"Returns time in minutes. If the mode argument is set to :exact (default), the result is represented as a rational number. Otherwise, if the mode is :round , the result is rounded to the nearest integer.","ref":"Membrane.Time.html#as_minutes/2","title":"Membrane.Time.as_minutes/2","type":"function"},{"doc":"Returns time in nanoseconds. If the mode argument is set to :exact (default), the result is represented as a rational number. Otherwise, if the mode is :round , the result is rounded to the nearest integer.","ref":"Membrane.Time.html#as_nanoseconds/2","title":"Membrane.Time.as_nanoseconds/2","type":"function"},{"doc":"Returns time in seconds. If the mode argument is set to :exact (default), the result is represented as a rational number. Otherwise, if the mode is :round , the result is rounded to the nearest integer.","ref":"Membrane.Time.html#as_seconds/2","title":"Membrane.Time.as_seconds/2","type":"function"},{"doc":"Returns one day in Membrane.Time units.","ref":"Membrane.Time.html#day/0","title":"Membrane.Time.day/0","type":"function"},{"doc":"Returns given amount of days in Membrane.Time units.","ref":"Membrane.Time.html#days/1","title":"Membrane.Time.days/1","type":"function"},{"doc":"Divides timestamp by a timebase. The result is rounded to the nearest integer. Examples: iex&gt; timestamp = 10 |&gt; Membrane.Time . seconds ( ) iex&gt; timebase = Ratio . new ( Membrane.Time . second ( ) , 30 ) iex&gt; Membrane.Time . divide_by_timebase ( timestamp , timebase ) 300","ref":"Membrane.Time.html#divide_by_timebase/2","title":"Membrane.Time.divide_by_timebase/2","type":"function"},{"doc":"Converts DateTime to Membrane.Time units.","ref":"Membrane.Time.html#from_datetime/1","title":"Membrane.Time.from_datetime/1","type":"function"},{"doc":"Converts iso8601 string to Membrane.Time units. If value is invalid, throws match error.","ref":"Membrane.Time.html#from_iso8601!/1","title":"Membrane.Time.from_iso8601!/1","type":"function"},{"doc":"Converts NTP timestamp (time since 0h on 1st Jan 1900) into Unix timestamp (time since 1st Jan 1970) represented in Membrane.Time units. NTP timestamp uses fixed point representation with the integer part in the first 32 bits and the fractional part in the last 32 bits.","ref":"Membrane.Time.html#from_ntp_timestamp/1","title":"Membrane.Time.from_ntp_timestamp/1","type":"function"},{"doc":"Returns one hour in Membrane.Time units.","ref":"Membrane.Time.html#hour/0","title":"Membrane.Time.hour/0","type":"function"},{"doc":"Returns given amount of hours in Membrane.Time units.","ref":"Membrane.Time.html#hours/1","title":"Membrane.Time.hours/1","type":"function"},{"doc":"Returns string representation of result of to_code/1 .","ref":"Membrane.Time.html#inspect/1","title":"Membrane.Time.inspect/1","type":"function"},{"doc":"Checks whether a value is Membrane.Time.t .","ref":"Membrane.Time.html#is_time/1","title":"Membrane.Time.is_time/1","type":"macro"},{"doc":"Returns one microsecond in Membrane.Time units.","ref":"Membrane.Time.html#microsecond/0","title":"Membrane.Time.microsecond/0","type":"function"},{"doc":"Returns given amount of microseconds in Membrane.Time units.","ref":"Membrane.Time.html#microseconds/1","title":"Membrane.Time.microseconds/1","type":"function"},{"doc":"Returns one millisecond in Membrane.Time units.","ref":"Membrane.Time.html#millisecond/0","title":"Membrane.Time.millisecond/0","type":"function"},{"doc":"Returns given amount of milliseconds in Membrane.Time units.","ref":"Membrane.Time.html#milliseconds/1","title":"Membrane.Time.milliseconds/1","type":"function"},{"doc":"Returns one minute in Membrane.Time units.","ref":"Membrane.Time.html#minute/0","title":"Membrane.Time.minute/0","type":"function"},{"doc":"Returns given amount of minutes in Membrane.Time units.","ref":"Membrane.Time.html#minutes/1","title":"Membrane.Time.minutes/1","type":"function"},{"doc":"Returns current monotonic time based on System.monotonic_time/0 in Membrane.Time units.","ref":"Membrane.Time.html#monotonic_time/0","title":"Membrane.Time.monotonic_time/0","type":"function"},{"doc":"Returns one nanosecond in Membrane.Time units.","ref":"Membrane.Time.html#nanosecond/0","title":"Membrane.Time.nanosecond/0","type":"function"},{"doc":"Returns given amount of nanoseconds in Membrane.Time units.","ref":"Membrane.Time.html#nanoseconds/1","title":"Membrane.Time.nanoseconds/1","type":"function"},{"doc":"Returns one VM native unit in Membrane.Time units.","ref":"Membrane.Time.html#native_unit/0","title":"Membrane.Time.native_unit/0","type":"function"},{"doc":"Returns given amount of VM native units in Membrane.Time units.","ref":"Membrane.Time.html#native_units/1","title":"Membrane.Time.native_units/1","type":"function"},{"doc":"Returns current POSIX time of operating system based on System.os_time/0 in Membrane.Time units. This time is not monotonic.","ref":"Membrane.Time.html#os_time/0","title":"Membrane.Time.os_time/0","type":"function"},{"doc":"Returns duration as a string with unit. Chosen unit is the biggest possible that doesn't involve precission loss. Examples iex&gt; import Membrane.Time iex&gt; 10 |&gt; milliseconds ( ) |&gt; pretty_duration ( ) &quot;10 ms&quot; iex&gt; 60_000_000 |&gt; microseconds ( ) |&gt; pretty_duration ( ) &quot;1 min&quot; iex&gt; 2 |&gt; nanoseconds ( ) |&gt; pretty_duration ( ) &quot;2 ns&quot;","ref":"Membrane.Time.html#pretty_duration/1","title":"Membrane.Time.pretty_duration/1","type":"function"},{"doc":"Returns current time in pretty format (currently iso8601), as string Uses os_time/0 under the hood.","ref":"Membrane.Time.html#pretty_now/0","title":"Membrane.Time.pretty_now/0","type":"function"},{"doc":"Works as as_days/2 with mode argument set to :round .","ref":"Membrane.Time.html#round_to_days/1","title":"Membrane.Time.round_to_days/1","type":"function"},{"doc":"Works as as_hours/2 with mode argument set to :round .","ref":"Membrane.Time.html#round_to_hours/1","title":"Membrane.Time.round_to_hours/1","type":"function"},{"doc":"Works as as_microseconds/2 with mode argument set to :round .","ref":"Membrane.Time.html#round_to_microseconds/1","title":"Membrane.Time.round_to_microseconds/1","type":"function"},{"doc":"Works as as_milliseconds/2 with mode argument set to :round .","ref":"Membrane.Time.html#round_to_milliseconds/1","title":"Membrane.Time.round_to_milliseconds/1","type":"function"},{"doc":"Works as as_minutes/2 with mode argument set to :round .","ref":"Membrane.Time.html#round_to_minutes/1","title":"Membrane.Time.round_to_minutes/1","type":"function"},{"doc":"Works as as_nanoseconds/2 with mode argument set to :round .","ref":"Membrane.Time.html#round_to_nanoseconds/1","title":"Membrane.Time.round_to_nanoseconds/1","type":"function"},{"doc":"Works as as_seconds/2 with mode argument set to :round .","ref":"Membrane.Time.html#round_to_seconds/1","title":"Membrane.Time.round_to_seconds/1","type":"function"},{"doc":"Divides timestamp by a timebase. The result is rounded to the nearest integer. Works this same as divide_by_timebase/2 . Examples: iex&gt; timestamp = 10 |&gt; Membrane.Time . seconds ( ) iex&gt; timebase = Ratio . new ( Membrane.Time . second ( ) , 30 ) iex&gt; Membrane.Time . round_to_timebase ( timestamp , timebase ) 300","ref":"Membrane.Time.html#round_to_timebase/2","title":"Membrane.Time.round_to_timebase/2","type":"function"},{"doc":"Returns one second in Membrane.Time units.","ref":"Membrane.Time.html#second/0","title":"Membrane.Time.second/0","type":"function"},{"doc":"Returns given amount of seconds in Membrane.Time units.","ref":"Membrane.Time.html#seconds/1","title":"Membrane.Time.seconds/1","type":"function"},{"doc":"Returns quoted code producing given amount time. Chosen unit is the biggest possible that doesn't involve precission loss. Examples iex&gt; import Membrane.Time iex&gt; 10 |&gt; milliseconds ( ) |&gt; to_code ( ) |&gt; Macro . to_string ( ) quote do 10 |&gt; Membrane.Time . milliseconds ( ) end |&gt; Macro . to_string ( ) iex&gt; 60_000_000 |&gt; microseconds ( ) |&gt; to_code ( ) |&gt; Macro . to_string ( ) quote do Membrane.Time . minute ( ) end |&gt; Macro . to_string ( ) iex&gt; 2 |&gt; nanoseconds ( ) |&gt; to_code ( ) |&gt; Macro . to_string ( ) quote do 2 |&gt; Membrane.Time . nanoseconds ( ) end |&gt; Macro . to_string ( )","ref":"Membrane.Time.html#to_code/1","title":"Membrane.Time.to_code/1","type":"function"},{"doc":"Returns time as a DateTime struct. TimeZone is set to UTC.","ref":"Membrane.Time.html#to_datetime/1","title":"Membrane.Time.to_datetime/1","type":"function"},{"doc":"Returns time as a iso8601 string.","ref":"Membrane.Time.html#to_iso8601/1","title":"Membrane.Time.to_iso8601/1","type":"function"},{"doc":"Returns time in VM native units. Rounded using Kernel.round/1.","ref":"Membrane.Time.html#to_native_units/1","title":"Membrane.Time.to_native_units/1","type":"function"},{"doc":"Converts the timestamp into NTP timestamp. May introduce small rounding errors.","ref":"Membrane.Time.html#to_ntp_timestamp/1","title":"Membrane.Time.to_ntp_timestamp/1","type":"function"},{"doc":"Returns current Erlang VM system time based on System.system_time/0 in Membrane.Time units. It is the VM view of the os_time/0 . They may not match in case of time warps. It is not monotonic.","ref":"Membrane.Time.html#vm_time/0","title":"Membrane.Time.vm_time/0","type":"function"},{"doc":"","ref":"Membrane.Time.html#t:non_neg/0","title":"Membrane.Time.non_neg/0","type":"type"},{"doc":"The time represented in Membrane's time units.","ref":"Membrane.Time.html#t:t/0","title":"Membrane.Time.t/0","type":"type"},{"doc":"A supervisor that allows to start utility processes under the pipeline's supervision tree. The supervisor is spawned with each component and can be obtained from callback contexts. The supervisor never restarts any processes, it just makes sure they terminate when the component that started them terminates. If restarting is needed, a dedicated supervisor should be spawned under this supervisor, like def handle_setup ( ctx , state ) do Membrane.UtilitySupervisor . start_link_child ( ctx . utility_supervisor , { MySupervisor , children : [ SomeWorker , OtherWorker ] , restart : :one_for_one } ) end","ref":"Membrane.UtilitySupervisor.html","title":"Membrane.UtilitySupervisor","type":"module"},{"doc":"Starts a process under the utility supervisor.","ref":"Membrane.UtilitySupervisor.html#start_child/2","title":"Membrane.UtilitySupervisor.start_child/2","type":"function"},{"doc":"Starts a process under the utility supervisor and links it to the current process.","ref":"Membrane.UtilitySupervisor.html#start_link_child/2","title":"Membrane.UtilitySupervisor.start_link_child/2","type":"function"},{"doc":"The pid of the Membrane.UtilitySupervisor process.","ref":"Membrane.UtilitySupervisor.html#t:t/0","title":"Membrane.UtilitySupervisor.t/0","type":"type"},{"doc":"","ref":"Membrane.ActionError.html","title":"Membrane.ActionError","type":"exception"},{"doc":"","ref":"Membrane.BinError.html","title":"Membrane.BinError","type":"exception"},{"doc":"","ref":"Membrane.CallbackError.html","title":"Membrane.CallbackError","type":"exception"},{"doc":"","ref":"Membrane.ElementError.html","title":"Membrane.ElementError","type":"exception"},{"doc":"","ref":"Membrane.LinkError.html","title":"Membrane.LinkError","type":"exception"},{"doc":"","ref":"Membrane.PadDirectionError.html","title":"Membrane.PadDirectionError","type":"exception"},{"doc":"","ref":"Membrane.PadError.html","title":"Membrane.PadError","type":"exception"},{"doc":"","ref":"Membrane.ParentError.html","title":"Membrane.ParentError","type":"exception"},{"doc":"","ref":"Membrane.PipelineError.html","title":"Membrane.PipelineError","type":"exception"},{"doc":"","ref":"Membrane.SetupError.html","title":"Membrane.SetupError","type":"exception"},{"doc":"","ref":"Membrane.StreamFormatError.html","title":"Membrane.StreamFormatError","type":"exception"},{"doc":"","ref":"Membrane.TimerError.html","title":"Membrane.TimerError","type":"exception"},{"doc":"","ref":"Membrane.UnknownChildError.html","title":"Membrane.UnknownChildError","type":"exception"},{"doc":"","ref":"Membrane.UnknownPadError.html","title":"Membrane.UnknownPadError","type":"exception"},{"doc":"Multimedia processing framework that focuses on reliability, concurrency and scalability. An easy to use abstraction layer for assembling mostly server-side applications that have to consume, produce or process multimedia streams. It puts reliability over amount of features. It is written in Elixir + C with outstanding Erlang VM underneath that gives us a rock solid and battle tested foundation.","ref":"readme.html","title":"Membrane Multimedia Framework","type":"extras"},{"doc":"This package provides core of the Membrane Multimedia Framework .","ref":"readme.html#membrane-core","title":"Membrane Multimedia Framework - Membrane Core","type":"extras"},{"doc":"Add the following line to your deps in mix.exs . Run mix deps.get . { :membrane_core , &quot;~&gt; 0.12.3&quot; } Or, if you'd like to try the latest release candidate, use this version: { :membrane_core , &quot;~&gt; 1.0.0-rc0&quot; }","ref":"readme.html#installation","title":"Membrane Multimedia Framework - Installation","type":"extras"},{"doc":"To get familiar with basic concepts and build your first application using Membrane Framework, visit Membrane Guide . API documentation is available at HexDocs . Moreover, we would like to invite you to take some of the Membrane Tutorials , based on real-life use cases.","ref":"readme.html#getting-started","title":"Membrane Multimedia Framework - Getting started","type":"extras"},{"doc":"Any contributions are more than welcome! You can help us improving Membrane by either contributing to the core (see opened issues ), extending our guide or by creating new elements. For more details see Contribution guide","ref":"readme.html#contributing","title":"Membrane Multimedia Framework - Contributing","type":"extras"},{"doc":"If you have any problems with Membrane Framework feel free to contact us via membrane tag at Elixir forum , mailing list , Discord or via e-mail .","ref":"readme.html#support-and-questions","title":"Membrane Multimedia Framework - Support and questions","type":"extras"},{"doc":"Copyright 2018, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Membrane Multimedia Framework - Copyright and License","type":"extras"},{"doc":"0.12.3 Fix bug in fields naming in callback contexts. #569 Update exit reasons of Membrane Components and their supervisors. #567","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fix bug in order of handling actions returned from callbacks.","ref":"changelog.html#0-12-2","title":"Changelog - 0.12.2","type":"extras"},{"doc":"Introduce :remove_link action in pipelines and bins. Add children groups - a mechanism that allows refering to multiple children with a single identifier. Add an ability to spawn anonymous children. Remove :playback action. Introduce :setup action. #496 Add Membrane.Testing.Pipeline.get_child_pid/2 . #497 Make callback contexts to be maps. #504 All Membrane Elements can be compatible till now on - pads working in :pull mode, handling different demand_units , can be now linked. Output pads working in :pull mode should have their demand_unit specified. If case it's not available, it's assumed that the pad handles demands in both :bytes and :buffers units. Remove _t suffix from types #509 Implement automatic demands in Membrane Sinks and Endpoints. #512 Add handle_child_pad_removed/4 callback in Bins and Pipelines. #513 Introduce support for crash groups in Bins. #521 Make sure enumerable with all elements being Membrane.Buffer.t() , passed as :output parameter for Membrane.Testing.Source won't get rewrapped in Membrane.Buffer.t() struct. Implement Membrane.Debug.Filter and Membrane.Debug.Sink . #552","ref":"changelog.html#0-12-1","title":"Changelog - 0.12.1","type":"extras"},{"doc":"Separate element name and pad arguments in handle_element {start, end}_of_stream signature #219 Refine communication between parent and its children #270 Add handle_call/3 callback in the pipeline, as well as a :reply and :reply_to actions. Rename handle_other/3 callback into handle_info/3 #334 Add Membrane.FilterAggregator that allows to run multiple filters sequentially within one process. #355 Log info about element's playback state change as debug, not as debug_verbose. #430 Rename Membrane.Time.to_&lt;unit name&gt;/1 into Membrane.Time.round_to_&lt;unit name&gt;/1 to indicate that the result will be rounded. Make Membrane.Time.&lt;plural unit name&gt;/1 accept %Ratio{} as an argument. Add Membrane.Time.round_to_timebase function. New spec action syntax - the structure of pipeline is now defined with the use of Membrane.ChildrenSpec Rename :caps to :stream_format . Use Elixir patterns as :accepted_format in pad definition. Delete :ok from tuples returned from callbacks Remove :type from specs passed to def_options/1 macro in bins and elements. Add Membrane.Testing.MockResourceGuard","ref":"changelog.html#0-11-0","title":"Changelog - 0.11.0","type":"extras"},{"doc":"Remove all deprecated stuff #399 Make Membrane.Pipeline.{prepare, play, stop} deprecated and add :playback action instead Make Membrane.Pipeline.stop_and_terminate deprecated and add Membrane.Pipeline.terminate/2 instead Add Membrane.RemoteControlled.Pipeline - a basic implementation of a Membrane.Pipeline that can be spawned and controlled by an external process #366 Disallow sending buffers without sending caps first #341 Refine the Membrane.Testing.Pipeline API - deprecate the Membrane.Testing.Pipeline.Options usage, use keyword list as options in Membrane.Testing.Pipeline.start/1 and Membrane.Testing.Pipeline.start_link/1","ref":"changelog.html#0-10-0","title":"Changelog - 0.10.0","type":"extras"},{"doc":"Automatic demands #313 Stop forwarding notifications by default in bins #358 More fine-grained control over emitted metrics #365 ### PRs not influencing public API: Added log metadata when reporting init in telemetry #376 Fix generation of pad documentation inside an element #377 Leaving static pads unlinked and transiting to a playback state other than :stopped will result in runtime error (previously only a warning was printed out). #389 It is possible now to assert on crash group down when using Testing.Pipeline. #391","ref":"changelog.html#0-9-0","title":"Changelog - 0.9.0","type":"extras"},{"doc":"Fixed PadAdded spec #359 PRs not influencing public API: Prevent internal testing notifications from reaching pipeline module #350 Fix unknown node error on distribution changes #352 Add new type of element, Membrane.Endpoint #382","ref":"changelog.html#0-8-2","title":"Changelog - 0.8.2","type":"extras"},{"doc":"allow telemetry in version 1.0 only #347 PRs not influencing public API: fix action enforcing CHANGELOG update with PR #345 Release membrane_core v0.8.1 #348","ref":"changelog.html#0-8-1","title":"Changelog - 0.8.1","type":"extras"},{"doc":"Release notes: PTS and DTS timestamps were added to Membrane.Buffer structure explicitly. Timestamps should no longer live in Membrane.Buffer.metadata field #335 . PRs not influencing public API: add CHANGELOG update verification #340 action enforcing changelog fix #342 bump version to 0.8.0 #344","ref":"changelog.html#0-8-0","title":"Changelog - 0.8.0","type":"extras"},{"doc":"Any contributions to Membrane Framework are welcome. If you would like contribute, but you're not sure how to start or have some questions, don't hesitate to contact us via channels described in README Before submitting code please read our Coding style guide When contributing to existing repo: fork it apply change on some branch create a PR from fork to our repo await feedback from someone from the team after passing the review, the PR will be merged If you wish to create a new plugin you can give us a shout and if it's something we want as a part of our ecosystem we'll create a repo for you, guide you on your work and maintain the plugin in future. However, if you feel confident enough to maintain it on your own, you can, of course, create your own repo and hex package - we only ask you to follow the naming convetions of the framework package and modules. In that case, don't forget to let us know about your work so we could include it on the list of available plugins.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"Between v0.11 and v0.12 some breaking changes have occurred, so here comes the guide that will help you adjust your code to the new API. See the release notes for details.","ref":"v0-12.html","title":"Upgrading to v0.12","type":"extras"},{"doc":"Upgrade membrane_core to v0.12.1 . defp deps do [ { :membrane_core , &quot;~&gt; 0.12.1&quot; } , ... ] end","ref":"v0-12.html#deps-upgrade","title":"Upgrading to v0.12 - Deps upgrade","type":"extras"},{"doc":"Now, if bin removes its pad (e.g. by removing an element linked to the bin's inner pad), bin's parent has to have implemented proper handle_child_pad_removed/4 callback, to handle it. If there is no such a callback, default behaviour is to raise an error. @impl true def handle_child_pad_removed ( :rtp , Pad . ref ( :rtp_input , _ssrc ) , _ctx , state ) do # ... end","ref":"v0-12.html#implement-handle_child_pad_removed-4-callback-in-bins-and-pipelines-if-it-is-needed","title":"Upgrading to v0.12 - Implement handle_child_pad_removed/4 callback in bins and pipelines, if it is needed","type":"extras"},{"doc":"Now, membrane pipelines enter the playing playback by default and they don't have to return a :playback action to do it. - @impl true - def handle_setup(_ctx, state) do - {[playback: :playing], state} - end Instead of it, there is a new action introduced in membrane_core v0.12, setup: :incomplete | :complete . If you want to defer a moment when a component enters the playing playback, you can return {:setup, :incomplete} action from handle_setup callback. If you do that, a component will enter the playing playback only when you return {:setup, :complete} action from another callback, e.g. handle_info . - @impl true - def handle_setup(_ctx, state) do - Process.send_after(self(), :play, 1000) - {[], state} - end - - @impl true - def handle_info(:play, _ctx, state) do - {[playback: :playing], state} - end + @impl true + def handle_setup(_ctx, state) do + Process.send_after(self(), :play, 1000) + {[setup: :incomplete], state} + end + + @impl true + def handle_info(:play, _ctx, state) do + {[setup: :complete], state} + end :setup action is available not only in pipelines but in bins and elements as well.","ref":"v0-12.html#remove-playback-action","title":"Upgrading to v0.12 - Remove :playback action","type":"extras"},{"doc":"Improvements in v0.11 required some breaking changes, so here comes the guide that will help you adjust your code to the new API. See the release notes for details.","ref":"v0-11.html","title":"Upgrading to v0.11","type":"extras"},{"doc":"Update membrane_core to v0.11 defp deps do [ { :membrane_core , &quot;~&gt; 0.11.0&quot; } , ... ] end","ref":"v0-11.html#deps-upgrade","title":"Upgrading to v0.11 - Deps upgrade","type":"extras"},{"doc":"Use the new return type of Membrane.Pipeline.start/3 and Membrane.Pipeline.start_link/3 - {:ok, pid} = Membrane.Pipeline.start_link(...) - send(pid, :message) + {:ok, _pipeline_supervisor, pipeline} = Membrane.Pipeline.start_link(...) + send(pipeline, :message) Now, when you get EXIT signal from pipeline , it means only that the pipeline process is dead. When you get EXIT signal from pipeline_supervisor , it means that the pipeline, all its children, descendants and utilities are dead. In tests, it's best to use Membrane.Testing.Pipeline.start_link_supervised!/1 . See the Testing section for details.","ref":"v0-11.html#use-the-new-way-of-interaction-with-membrane-pipeline","title":"Upgrading to v0.11 - Use the new way of interaction with Membrane.Pipeline","type":"extras"},{"doc":"Update type of tuples returned from callbacks to {actions, state} If callback returns: {:ok, state} , change it to {[], state} - {:ok, state} + {[], state} {{:ok, actions}, state} , change it to {actions, state} - {{:ok, event: {pad, event}}, state} + {[event: {pad, event}], state} {:error, reason} or {{:error, reason}, state} , raise an error, instead of returning value from callback - {:error, :something_went_wrong} + raise &quot;Something went wrong!&quot;","ref":"v0-11.html#update-format-of-tuples-returned-from-callbacks","title":"Upgrading to v0.11 - Update format of tuples returned from callbacks","type":"extras"},{"doc":"Add context argument to handle_init - def handle_init(options) do + def handle_init(_context, options) do Instead of handle_stopped_to_prepared/2 , implement handle_setup/2 - def handle_stopped_to_prepared(ctx, state) do + def handle_setup(ctx, state) do In general, handle_init should cover simple tasks like parsing options, while handle_setup is there for complex and long-lasting operations. See the docs for details. Rename handle_prepared_to_playing/2 to handle_playing/2 - def handle_prepared_to_playing(ctx, state) do + def handle_playing(ctx, state) do Remove handle_playing_to_prepared/2 , handle_prepared_to_stopped/2 and handle_shutdown/2 . Instead, use Membrane.ResourceGuard , Membrane.UtilitySupervisor or handle_terminate_request/2 : - def handle_stopped_to_prepared(_ctx, state) do - resource = create_resource() - {:ok, %{state | resource: resource}} - end - ... - def handle_prepared_to_stopped(_ctx, state) do - cleanup(state.resource) - end + def handle_setup(ctx, state) do + resource = create_resource() + # The resource will be automatically cleaned up when the component terminates + # unless you do that earlier by calling `Membrane.Resource.cleanup/2` + Membrane.ResourceGuard.register( + ctx.resource_guard, + fn -&gt; cleanup(resource) + end) + {[], %{state | resource: resource}} + end - def handle_stopped_to_prepared(_ctx, state) do - {:ok, pid} = GenServer.start_link(SomeServer, options) - {:ok, %{state | utility: pid}} - end - ... - def handle_prepared_to_stopped(_ctx, state) do - GenServer.stop(state.utility) - end + def handle_setup(ctx, state) do + Membrane.UtilitySupervisor.start_link_child(ctx.utility_supervisor, SomeServer) + {[], %{state | utility: pid}} + end - def handle_prepared_to_stopped(_ctx, state) do - do_some_work(state) - {:ok, state} - end + def handle_terminate_request(ctx, state) do + # This will only be called upon graceful termination, + # i.e. `Membrane.Pipeline.terminate/1`, termination of parent + # or being removed by parent (`remove_child` action). + # Won&#39;t be called if component crashes. + do_some_work(state) + + # You can defer component termination by not returning `:terminate` + # from this callback and returning it later instead. + {[terminate: :normal], state} + end Rename handle_other/3 into handle_info/3 (unless your handle_other/3 was used to receive message from parent - if so, see subsection about handle_parent_notification/3 below) @impl true - def handle_other(message, _ctx, state) do + def handle_info(message, _ctx, state) do Rename playback_state to playback in contexts. Rely on :stopped instead of :prepared - def handle_other(message, %{playback_state: :playing}, state) do + def handle_info(message, %{playback: :playing}, state) do - def handle_other(message, %{playback_state: :prepared}, state) do + def handle_info(message, %{playback: :stopped}, state) do In elements, rename handle_caps/4 to handle_stream_format/4 - def handle_caps(pad_ref, caps, ctx, state) do + def handle_stream_format(pad_ref, stream_format, ctx, state) do In pipelines and bins, change arguments in handle_element_start_of_stream and handle_element_end_of_stream , since till now on they accept children name and pad reference as two separate arguments instead of storing them as tuple in the first argument. use Membrane.Pipeline ... @impl true - def handle_element_end_of_stream({child_name, pad_ref}, context, state) + def handle_element_end_of_stream(child_name, pad_ref, context, state) In pipelines and bins, rename handle_notification/4 into handle_child_notification/4 @impl true - def handle_notification(notification, child, context, state) do + def handle_child_notification(notification, child, context, state) do In elements and bins, add an implementation of handle_parent_notification/3 in place of the handle_other/3 that were responsible for receiving messages from the parents. @impl true - def handle_other(parent_notification, context, state) do + def handle_parent_notification(parent_notification, context, state) do","ref":"v0-11.html#update-callbacks","title":"Upgrading to v0.11 - Update callbacks","type":"extras"},{"doc":"In elements: :caps -&gt; :stream_format :notify -&gt; :notify_parent In bins: :notify -&gt; :notify_parent :forward -&gt; :notify_child In pipelines: :forward -&gt; :notify_child - {{:ok, caps: %My.Format{freq: 1}}, state} + {[stream_format: %My.Format{freq: 1}], state} use Membrane.Bin ... - {{:ok, [forward: {child, :response}]}, state} + {[notify_child: {child, :response}], state}","ref":"v0-11.html#rename-actions-returned-from-callbacks","title":"Upgrading to v0.11 - Rename actions returned from callbacks","type":"extras"},{"doc":"Instead of using :caps , use :accepted_format option. Option :accepted_format can receive: Module name - caps: My.Format + accepted_format: My.Format Elixir pattern - caps: {My.Format, field: one_of([:some, :enumeration])} + accepted_format: %My.Format{field: value} when value in [:some, :enumeration] - caps: :any + accepted_format: _any Call to any_of function. You can pass there as many arguments, as you want. Each argument should be an Elixir pattern or a module name - caps: [My.Format, My.Another.Format] + accepted_format: any_of(My.Format, My.Another.Format) - caps: [My.Format, {My.Another.Format, field: :strict_value}, My.Yet.Another.Format] + accepted_format: any_of(My.Format, %My.Another.Format{field: :strict_value}, My.Yet.Another.Format)","ref":"v0-11.html#update-pads-definitions","title":"Upgrading to v0.11 - Update pads definitions","type":"extras"},{"doc":"This section applies to options defined via def_options macro and pad options defined in def_input_pad or def_output_pad . Remove :type key and related value from the options definitions. Add :spec instead, if it hasn't been added before, and proper :inspector , if the option has a default value, that shouldn't be inspected by inspect/1 during generating docs. - def_options tick_interval: [ - type: :time, - default: Membrane.Time.seconds(1) - ], - process: [ - type: :pid - ] + def_options tick_interval: [ + spec: Membrane.Time.t(), + default: Membrane.Time.seconds(1), + inspector: &amp;Membrane.Time.inspect/1 + ], + process: [ + spec: pid() + ]","ref":"v0-11.html#update-options-definitions","title":"Upgrading to v0.11 - Update options definitions","type":"extras"},{"doc":"Rename Membrane.Time.to_&lt;unit name&gt;/1 into Membrane.Time.round_to_&lt;unit name&gt;/1 : - rounded_time = Membrane.Time.to_seconds(time) + rounded_time = Membrane.Time.round_to_seconds(time)","ref":"v0-11.html#membrane-time-functions","title":"Upgrading to v0.11 - Membrane.Time functions","type":"extras"},{"doc":"Children definitions syntax (previously known as ParentSpec , after the name of a structure used to define children), that was used in Membrane.Pipeline.Action.spec_t and Membrane.Bin.Action.spec_t actions, has changed. Since there are quite a few changes concerning children definition, we have decided to present them in the subsections below. Update children names We have restricted the available names for the children. Previously, the children name could be of any() type, now it is specified as follows: tuple() | atom() . In case you have used a child name that does not match the new children names specification, you can wrap that name into a tuple, i.e.: - child_name = [:why_would, :i_use, :a_list, :as_a, :child_name?] + child_name = {:child_name, [:why_would, :i_use, :a_list, :as_a, :child_name?]} Update the children and links definition Rename the following function calls: Membrane.ParentSpec.link/1 -&gt; Membrane.ChildrenSpec.get_child/1 Membrane.ParentSpec.link/2 -&gt; Membrane.ChildrenSpec.child/2 Membrane.ParentSpec.link_bin_input/1 -&gt; Membrane.ChildrenSpec.bin_input/1 Membrane.ParentSpec.to/2 -&gt; Membrane.ChildrenSpec.get_child/2 Membrane.ParentSpec.to/3 -&gt; Membrane.ChildrenSpec.child/4 Membrane.ParentSpec.to_bin_output/2 -&gt; Membrane.ChildrenSpec.bin_output/2 - import Membrane.ParentSpec - children = %{source: SomeSource, filter: SomeFilter} - links = [link(:source) |&gt; to(:another_filter, SomeFilter) |&gt; to(:filter) |&gt; to(:sink, SomeSink)] + import Membrane.ChildrenSpec + structure = [ + child(:source, SomeSource), + child(:filter, SomeFilter), + get_child(:source) |&gt; child(:another_filter, SomeFilter) |&gt; get_child(:filter) |&gt; child(:sink, SomeSink) + ] Substitute the Membrane.ParentSpec structure with a tuple %Membrane.ParentSpec{children: children, links: links, options...} should be changed into {structure, options...} with the children and links defined as described in the step above. Note, that there is no distinguishement between children and links - the children and links can be concatenated, so in case you have a separate children and links lists, simply merge them. - spec = %Membrane.ParentSpec{children: children, links: links, node: another_node, log_metadata: metadata} + spec = {structure, node: another_node, log_metadata: metadata} Below there is an example that aggregates the changes that need to be done to concerning the :spec action preparation: - children = %{source: SomeSource, filter: SomeFilter} - links = [link(:source) |&gt; to(:another_filter, SomeFilter) |&gt; to(:filter) |&gt; to(:sink, SomeSink)] - spec = Membrane.ParentSpec{children: children, links: links, crash_group: {:first_group, :temporary}, node: another_node} + structure = [ + child(:source, SomeSource), + child(:filter, SomeFilter), + get_child(:source) |&gt; child(:another_filter, SomeFilter) |&gt; get_child(:filter) |&gt; child(:sink, SomeSink) ] + spec = {structure, crash_group: {:first_group, :temporary}, node: another_node} - {{:ok, spec: spec}, %{}} + {[spec: spec], %{}}","ref":"v0-11.html#update-the-children-definitions","title":"Upgrading to v0.11 - Update the children definitions","type":"extras"},{"doc":"Instead of using Membrane.Testing.Pipeline.start_link/1 , use Membrane.Testing.Pipeline.start_link_supervised!/1 - {:ok, pipeline} = Membrane.Testing.Pipeline.start_link(options) + pipeline = Membrane.Testing.Pipeline.start_link_supervised!(options) + # The pipeline will be shut down at the end of the test. The Membrane.Testing.Pipeline.options() has also changed - now there is no more separate :links and :children fields. Instead, you need to use a :structure field: - {:ok, pipeline} = Membrane.Testing.Pipeline.start_link(children: children, links: links) + {:ok, pipeline} = Membrane.Testing.Pipeline.start_link(structure: structure) In order to wait for the Membrane.Testing.Pipeline to get into the :playing playback, use assert_pipeline_play/2 instead of assert_pipeline_playback_changed/4 : - assert_pipeline_playback_changed(pipeline, :prepared, :playing) + assert_pipeline_play(pipeline)","ref":"v0-11.html#testing","title":"Upgrading to v0.11 - Testing","type":"extras"},{"doc":"Between v0.11 and v1.0.0-rc0 some breaking changes have occurred, so here comes the guide that will help you adjust your code to the new API. See the release notes for detailed description of the changes. Deps upgrade Update membrane_core to v1.0.0-rc0 defp deps do [ { :membrane_core , &quot;~&gt; 1.0.0-rc0&quot; } , ... ] end Remove the pipeline's :playback action There is no more :playback action available, as the pipeline will start playing automatically once its setup is completed. If you need to start the pipeline as soon as possible, simply do not return the :playback action in Membrane.Pipeline.handle_init/2 or Membrane.Pipeline.handle_setup/2 callbacks: @impl true def handle_setup(_ctx, state) do ... - {[playback: :playing], state} + {[], state} end In case you need to defer the moment the pipeline starts playing, and for this purpose you have returned :playback action in some other callback than handle_init or handle_setup , now you need to do two things - first, mark the setup as incomplete with Membrane.Pipeline.Action.setup/0 action returned from handle_setup , to prevent it from automatically changing the playback to :playing : + @impl true + def handle_setup(_ctx, state) do + {[setup: :incomplete], state} + end Then, you need to return setup: :complete instead of playback: :playing action in a callback after which completion you want your pipeline to start playing: @impl true def handle_info(:now_start_playing, _ctx, state) do ... - {[playback: playing], state} + {[setup: :complete], state} end Note that the :setup action is also available in elements and bins and its main purpose is to handle long, asynchronous initialization of a component. See Membrane.Bin.Action.setup/0 and Membrane.Element.Action.setup/0 . Rename handle_process and handle_write into handle_buffer Names of the callbacks that are used to process buffers have been unified. This applies to: Membrane.Filter.handle_process/4 and Membrane.Filter.handle_process_list/4 Membrane.Endpoint.handle_write/4 and Membrane.Endpoint.handle_write_list/4 Membrane.Sink.handle_write/4 and Membrane.Sink.handle_write_list/4 and they became Membrane.Element.WithInputPads.handle_buffer/4 and Membrane.Element.WithInputPads.handle_buffers_batch/4 , respectively: @impl true - def handle_process(pad, buffer, ctx, state) do + def handle_buffer(pad, buffer, ctx, state) do ... end @impl true - def handle_process_list(pad, buffers, ctx, state) do + def handle_buffers_batch(pad, buffers, ctx, state) do ... end Change mode and demand_mode options to flow_control in pads' definitions in elements For input pads, change: use Membrane.Filter # or Sink or Endpoint - def_input_pad :input, mode: :push, ... + def_input_pad :input, flow_control: :push, ... - def_input_pad :input, mode: :pull, demand_mode: :auto, demand_unit: :buffers, ... + def_input_pad :input, ... # (because `flow_control: :auto` is the default whenever available - currently in Filters) # Note that having `flow_control: :auto` doesn&#39;t allow to pass `demand_unit`, # as it&#39;s determined automatically - def_input_pad :input, mode: :pull, demand_unit: :buffers, ... + def_input_pad :input, flow_control: :manual, demand_unit: :buffers, ... Same goes for output pads: use Membrane.Filter # or Source or Endpoint - def_output_pad :output, mode: :push, ... + def_output_pad :output, flow_control: :push, ... - def_output_pad :output, mode: :pull, demand_mode: :auto, ... + def_output_pad :output, ... - def_output_pad :output, mode: :pull, ... + def_output_pad :output, flow_control: :manual, ... Check Membrane.Pad.element_spec/0 for details. Remove mode and demand_unit from pads definitions in bins use Membrane.Bin - def_input_pad :input, mode: :pull, demand_unit: :buffers, ... + def_input_pad :input, ... - def_output_pad :output, mode: :push, ... + def_output_pad :output, ... Check Membrane.Pad.bin_spec/0 for details. Don't refer to callback contexts as to structs Callback contexts are now plain maps instead of structs. So, for example, if you happen to have a match like below, convert it to a match on a map: @impl true - def handle_info(message, %Membrane.Element.CallbackContext.Info{pads: pads}, state) do + def handle_info(message, %{pads: pads}, state) do ... end Additionally, there's no direction field anymore in the callback context for handle_pad_added and handle_pad_removed - the direction can be determined by the pad name. All other fields remain the same. @impl true - def handle_pad_added(_pad, %{direction: :input}, state) do + def handle_pad_added(Pad.ref(:input, _id), _ctx, state) do ... end Check Membrane.Element.CallbackContext.t/0 , Membrane.Bin.CallbackContext.t/0 and Membrane.Pipeline.CallbackContext.t/0 for outline of what can be found in the contexts. Additionally, each callback that provides extra fields in the context, has them mentioned in its docs. Use Membrane.RCPipeline instead of Membrane.RemoteControlled.Pipeline - pipeline = Membrane.RemoteControlled.Pipeline.start_link!() + pipeline = Membrane.RCPipeline.start_link!() Same goes for Membrane.RemoteControlled.Message -&gt; Membrane.RCMessage receive do - %Membrane.RemoteControlled.Message.Notification{data: data} -&gt; data + %Membrane.RCMessage.Notification{data: data} -&gt; data end Use Membrane.Time.as_&lt;unit&gt;(time, :round) instead of Membrane.Time.round_to_&lt;unit&gt;(time) - Membrane.Time.round_to_milliseconds(time) + Membrane.Time.as_milliseconds(time, :round) There is one exception for round_to_timebase , which changed to divide_by_timebase : - Membrane.Time.round_to_timebase(time, timebase) + Membrane.Time.divide_by_timebase(time, timebase) Check Membrane.Time for details. Remove _t suffix when referring to Membrane types - Membrane.Pad.ref_t() + Membrane.Pad.ref()","ref":"v1-0-0-rc0.html","title":"Upgrading to v1.0.0-rc0","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2018 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"}]